

import java.util.*;
import java.io.*;

public class Cache implements Serializable {

	private int MAX;
	private int refresh;
	private Tempo t;
	private Hashtable mycache;
	
	public Cache(int msec) {
	
		this.mycache = new Hashtable();
		this.refresh = msec;
		this.MAX = 1000+1000*(60+60*(60+60*24));
	}
	
	
	private int ora() {
	
		t = new Tempo();
			 
		return t.mil_ora();
	}
		
	public void setRefresh(int msec) {
	
		this.refresh = msec;
	}
	
	public void insert(String Dom, String Addr, String Port) {
		String tot = Dom.concat(":"+Addr+":"+Port);
		insert(tot);
	}
	public void insert(String Dom, String Addr) {
		String tot = Dom.concat(":"+Addr);
		insert(tot);
		
	}
	public synchronized void insert(String Dom) {
		if (mycache.containsKey(Dom)) {
			if (!mycache.get(Dom).equals("-1")) {
				mycache.remove(Dom) ;
				mycache.put(Dom,new String(""+ora()));
			}
			
		}
		else {
			mycache.put(Dom,new String(""+ora()));
		}
		System.out.println(" inserito "+Dom);
		
	}
	
	public void permInsert(String Dom, String Addr) {
		String tot = Dom.concat(":"+Addr);
		permInsert(tot);
		
	}
	
	public void delete(String Dom, String Addr, String Port) {
		delete(Dom.concat(":"+Addr+":"+Port));
	}
		
	public void delete(String Dom, String Addr) {
		delete(Dom.concat(":"+Addr));
	}
		
	public synchronized void delete(String Dom) {
		mycache.remove(Dom) ;
	}
	public synchronized void permInsert(String Dom) {
		if (mycache.containsKey(Dom)) {
			if (!mycache.get(Dom).equals("-1")) {
				mycache.remove(Dom) ;
				mycache.put(Dom,"-1");
			}
			
		}
		else {
			mycache.put(Dom,"-1");
		}
	}
	public String get(String Dom, String Addr, String Port) {
		return get(Dom.concat(":"+Addr+":"+Port));
	}
	public String get(String Dom, String Addr) {
		return get(Dom.concat(":"+Addr));
	}
	public String get(String Dom) {
		System.out.println("Accesso alla cache : "+Dom);	
		String ris = (String) mycache.get(Dom);
		if(ris!=null){
			int old = Integer.parseInt(ris);
			System.out.println(" old :"+old+" ora : "+ora());	
			if(old == -1) return ris;
			int val;
			if((val = ora()-old)>=0) {
				System.out.println(" 1 :"+val+" "+ris);	
				if(val < refresh ) {
					System.out.println(" Valore di cache "+val);	
					return ris;
				}
			}
			else if((MAX+val) < refresh ) return ris; 
		}
		return "";
		
	
	}
	public String stampa(){
		String ret ="";
		for (Enumeration u = mycache.keys() ; u.hasMoreElements() ;) {
	         		ret = ret.concat((String)u.nextElement()+"\n");
	
         		}
		return ret;
		
	}
	
}