

import java.net.*;
import java.io.*;
import java.util.*;
import iaik.utils.CryptoUtils;
//import iaik.security.provider.IAIK;
import iaik.security.rsa.*;
import java.security.*;
import java.security.spec.*;
//import java.security.interfaces.*;
import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;

public class Connessione {
	
	private Socket sock;
	private boolean stato = false;
	//private Hashtable hashkey;
	private RSAPublicKey puk; 
	private RSAPrivateKey prk; 
	private SecretKey Deskey;
	//private String[] lista;
	//private String[] result;
	//private int num; //=0;
	//private int lung;
	private Firma firma = null;
	private Firma myfirma = null;
	private boolean RSAcriptato = false;
	private boolean DEScriptato = false;
	private boolean chiaro = false;
	//private byte[] ciphertext;
	private ByteArrayOutputStream bos =null;
	private ByteArrayInputStream bis =null ;
	private ObjectOutputStream out,dataout=null;
	private ObjectInputStream in,datain=null;
	private byte[] tempb = null;
	private String chi;
	private String me;
	public Connessione(String io) {
		me = io;
	}
		
       	public Connessione(String server,RSAPublicKey puk, RSAPrivateKey prk,String io) {
       		chi = server;
       		inizio(server,puk,prk);
       		me = io;
       	}
       		
       	public void inizio(String server,RSAPublicKey puk, RSAPrivateKey prk) {
       		chi = server;
       		//this.lung = 1;
       		this.puk = puk;
       		this.prk=prk;
       		//lista = null;
       		
       		//result = new String[lung];
		try {
       			inizio(server);
       		} catch(Exception e) {
       			stato = false;	
       		}
       		
       		
       	}
       	private void inizio (String server) throws Exception{
       		//bos = new ByteArrayOutputStream();
	       	//out = new ObjectOutputStream(bos);
       		chi = server;
       		int j = server.indexOf(':');
       		InetAddress addr = InetAddress.getByName(server.substring(0,j));
		int port = Integer.parseInt(server.substring(j+1,server.length()));
		sock  = new Socket(addr, port);
//		sock.setTcpNoDelay(true);
		//puk = (RSAPublicKey) hashkey.get(server);
//		if(puk==null) System.out.println("chiave puk nulla : Server "+server);
		stato = true;
			
          
	}
       	/*
       	public Connessione(Vector listav,Hashtable hashkey, RSAPrivateKey prk) {
       		
       		this.lung = listav.size();
       		this.hashkey = hashkey;
       		this.prk=prk;
       		lista = new String[lung];
       		listav.copyInto(this.lista);
       		result = new String[lung];
       		inizio(0);
       	       		
       	}
       	*/
       	public Connessione(Socket sock,RSAPrivateKey prk,String io) {
       		
       		try {
       			//bos = new ByteArrayOutputStream();
	       		//out = new ObjectOutputStream(bos);
       			this.prk=prk;
       			this.sock = sock;
//      			sock.setTcpNoDelay(true);
			stato = true;
			me = io;
			
			
		} catch(Exception e) {System.out.println("errore in connessione"+e.getMessage());}
		
       	}
       	public boolean firma(String from){
       		try {
       			Firma fir = new Firma();
       			fir.crea(prk,from,chi);
       			myfirma = fir;
       			return true;  			
       			
       		}
       		catch(Exception e){
       			return false;
       			
       		}	
       		
       	}
       	/*
       	public String verificaFirma(String me,long l){
       		try {
       			//System.out.println("verifica firma 1");
       			//if(hashkey == null) System.out.println("gestore chiavi non trovato");
       			//if(puk == null) puk = (RSAPublicKey) hashkey.get(firma.getUser());
			System.out.println("verifica firma 1");
			if(puk == null) {
				System.out.println("chiave pubblica nulla");
				return "";
			}
				
       			System.out.println("verifica firma 2");
       			if(firma.verifica(puk))
       				if(me.equals(firma.getTo())) return firma.getUser();
       				
       			return "";
       		}
       		catch(Exception e){
       			System.out.println("errore verificaFirma "+e.getMessage());       			
       			return "";
       			
       		}	
       		
       	}
       	*/
       	public Firma getFirma() {
//       		if(firma == null) System.out.println("Firma nulla in connessione");  
       		return firma;	
       		
       	}
       	private void inizio(RSAPublicKey puk) {
       		try{
       			//bos = new ByteArrayOutputStream();
	       		//out = new ObjectOutputStream(bos);
	       		this.puk = puk;
	       	} catch(Exception e) {
	       		System.out.println("Error "+e.getMessage());
	       	}
       	}
       	
       	private void inizio() {
       		try{
       	      		//bos = new ByteArrayOutputStream();
	       		//out = new ObjectOutputStream(bos);
	       	} catch(Exception e) {
	       		System.out.println("Error inizio"+e.getMessage());
	       	}
       	}
   	public String ip() {
   		return (sock.getInetAddress()).getHostAddress();
   	}
   	public String remoteIp() {
   		return sock.getInetAddress().getHostAddress();
   		
   	}
       	public String chi() {
       		/*
       		return (sock.getInetAddress()).getHostAddress().concat(":"+sock.getPort());  
       		try {
       			return sock.getInetAddress().getHostAddress();
       		} catch(Exception e) {
       			System.out.println("Chi error : ");
       			return null;
       		}
       		*/
       		return chi;
       		
       	}
   	
       	public boolean stato () {
       		return stato;
       	}
       	public boolean RSAPubKey() {
       		return (puk==null)?false:true;
       	}
       	public boolean isRSAcriptato() {
       		return RSAcriptato;
       	}
       	public boolean isDEScriptato() {
       		return DEScriptato;
       	}
       	public boolean isChiaro() {
       		return chiaro;
       	}
       	public boolean isFirmato() {
       		if(firma==null) return false;
       		else return true;
       	}
       
/*
       	private void inizio (int h) {
       		
		int i;       		
       		for(i=h;(i<lung&&!stato);i++) {
       			try {
       				inizio(lista[i]);
       			} catch (Exception e) {
       				// memorizzo info sul non avvenuto collegamento 
       				result[i] = e.getMessage();
       			}
       		}
       		
       	}
       	
*/
       	public void  cleanUp() throws IOException{
		sock.close();
		
	}
      	
       	
       
	public void manda(Object obj) {
		if(stato) {
			try {	if(bos ==null) bos = new ByteArrayOutputStream();
				if(out ==null) out = new ObjectOutputStream(bos);
				out.writeObject(obj);
				if(obj == null ) System.out.println("manda oggetto nullo");
				//System.out.println("manda lunghezza oggetto : "+java.lang.reflect.Array.getLength(Cript.ObjToByte(obj)));
				
			} catch(Exception e) {
				System.out.println("manda error"+e.getMessage());
				//result[num] = e.getMessage();
				stato = false;
				
			}
		}
	}
	
	public void mandachiaro() {
      		try {	byte[] b = bos.toByteArray();
      			//System.out.println("mandachiaro lunghezza tempb : "+java.lang.reflect.Array.getLength(b));
	      		
			dataout = new ObjectOutputStream(new BufferedOutputStream(sock.getOutputStream()));
			if (myfirma!=null) dataout.writeObject(myfirma);
			else dataout.writeObject(me);
			dataout.writeObject(b);
			dataout.flush();
			//RSAcriptato = false;
	      	} catch(Exception e) {
	      		System.out.println("mandachiaro Error "+e.getMessage());
	      	}
      	}
	public void mandacriptato() {
//		System.out.println("mandacriptato controllo chiave pubblica: "+puk);	
		if(DEScriptato) mandaDesCriptato();
		else {
	      		byte[] b = bos.toByteArray();
	      		int lenb =java.lang.reflect.Array.getLength(b);
//	      		System.out.println("mandacriptato 1 len : "+lenb);	
	      		try {	
		      		
//		      		System.out.println("mandacriptato 2");	
		      		dataout = new ObjectOutputStream(new BufferedOutputStream(sock.getOutputStream()));
		      		byte[] h = Cript.cripta(b,puk);
		      		if (myfirma!= null) dataout.writeObject(myfirma);
				else dataout.writeObject(me);
				dataout.writeObject(h);
//				System.out.println("mandacriptato 4");	
				dataout.flush();
				
				//criptato = true;
		      	} catch(Exception e) {
		      		System.out.println("mandacriptato Error "+e.getMessage());
		      		
		      	}
	      	}
      	}
	public void leggicriptato() {
		try {	
			if (datain==null)  datain = new ObjectInputStream(new BufferedInputStream(sock.getInputStream()));
			Object temp = datain.readObject();
			try {
				firma = (Firma) temp;
				tempb = (byte[]) datain.readObject();						
//				System.out.println("firmato");
			} catch(Exception e) {
				
				try {
					chi = (String) temp;
					tempb = (byte[]) datain.readObject();
//					System.out.println("non firmato me");
				
				} catch(Exception e2) {
//					System.out.println("non firmato");
					tempb = (byte[]) temp;
				}
				
			}
			byte[] g = Cript.decripta(tempb,prk);
			if(g != null) {
				in = new ObjectInputStream(new ByteArrayInputStream(g));
				RSAcriptato = true;	
			} else {
				in = new ObjectInputStream(new ByteArrayInputStream(tempb));
				chiaro = true;
				
			}
		} catch(Exception e) {
//			System.out.println("leggicriptato error "+e.getMessage());
			try {
				in = new ObjectInputStream(new ByteArrayInputStream(tempb));
			}catch(Exception ee) {
			}
			//criptato = false;
			
			
		}	
		
	}
	/*
	public void leggichiaro() {
		try {	
			if (tempb == null) {
				if (datain == null) datain = new ObjectInputStream(new BufferedInputStream(sock.getInputStream()));
				tempb = (byte[]) datain.readObject();
				
			}
			in = new ObjectInputStream(new ByteArrayInputStream(tempb));
			
		} catch(Exception e) {
			System.out.println("leggi error "+e.getMessage());
		}		
	}
	*/
	public Object leggi() {
		try {	Object l = in.readObject();
			//System.out.println("leggi lunghezza tempb : "+java.lang.reflect.Array.getLength(Cript.ObjToByte(l)));
			return l;
		}catch(Exception e) {
			System.out.println("Error leggi"+e.getMessage());
			stato = false;
		return null;
		}
		
	}
	public Object leggi(RSAPrivateKey prk) {
		try {	byte[] ciphertext = (byte[]) in.readObject();
			Cipher rsa = Cipher.getInstance("RSA");
			rsa.init(Cipher.DECRYPT_MODE,puk);
			byte[] res = rsa.doFinal(ciphertext);
			return Cript.ByteToObj(res);
		}catch(Exception e) {
			System.out.println("Error leggiRSA");
		return null;
		}
		
	}
	

/*          da utilizzare per connessioni criptate con des */


       	public void inizio(SecretKey Deskey,String server) {
       		try{
       			int j = server.indexOf(':');
	       		InetAddress addr = InetAddress.getByName(server.substring(0,j));
			int port = Integer.parseInt(server.substring(j+1,server.length()));
			sock  = new Socket(addr, port);
			stato = true;
       			inizio(Deskey);
       			
	       	} catch(Exception e) {
	       		System.out.println("Error inizio"+e.getMessage());
	       		stato = false;
	       	}
       	}
       	public void inizio(SecretKey Deskey) {
       		try{
       			
       			bos = new ByteArrayOutputStream();
	       		out = new ObjectOutputStream(bos);
	       		this.Deskey = Deskey;
	       		stato = true;
	       		//tempb = null;
	       		out.writeObject("ok");
	       	} catch(Exception e) {
	       		System.out.println("Error inizio"+e.getMessage());
	       		stato = false;
	       	}
       	}
       	public Object leggi(SecretKey Deskey) {
		try {	byte[] b = (byte[]) in.readObject();
			byte[] cltext = Cript.decripta(b,Deskey);
			return Cript.ByteToObj(cltext);
			
			
		}catch(Exception e) {
			System.out.println("Error leggi"+e.getMessage());
		return null;
		}
		
	}
       	public void manda(Object obj,SecretKey Deskey) {
		if(stato) {
			try {	byte[] b = Cript.ObjToByte(obj);
				byte[] crtext = Cript.cripta(b,Deskey);
				
				out.writeObject(crtext);
			} catch(Exception e) {
				//result[num] = e.getMessage();
				stato = false;
				System.out.println("manda2 error"+e.getMessage());
			}
		}
	}
       	public void mandaDesCriptato() {
      		byte[] b = bos.toByteArray();
      		
      		int lendati = java.lang.reflect.Array.getLength(b);
      		
      		try {	
      			
	      		dataout = new ObjectOutputStream(new BufferedOutputStream(sock.getOutputStream()));
			//System.out.println("lung dati : "+lendati);
			
			byte[] crtext = Cript.cripta(b,Deskey);
			dataout.writeObject(crtext);
		
			dataout.flush();
			
	      	} catch(Exception e) {
	      		System.out.println("mandacriptato Error "+e.getMessage());
	      		
	      	}
      	}
       	public boolean leggiDesCriptato() {
		try {	
			if(tempb == null) {
				if (datain==null) datain = new ObjectInputStream(new BufferedInputStream(sock.getInputStream()));
				tempb = (byte[]) datain.readObject();
			}
			byte[] cleartext = Cript.decripta(tempb,Deskey);
                       	in = new ObjectInputStream(new ByteArrayInputStream(cleartext));
			if (((String) leggi()).equals("ok")) {
				chiaro = false;
				DEScriptato = true;	
				return true;
			} else {
				//criptato = false;
				return false;
			}
			
		} catch(Exception e) {
//			System.out.println("leggiDescriptato error "+e.getMessage());
			if(Deskey == null) System.out.println("errore chiave privata nulla");
			DEScriptato = false;
			return false;
		}	
	}
}