

import java.io.*;
import iaik.security.rsa.*;
import javax.crypto.*;
import iaik.utils.CryptoUtils;
import iaik.security.provider.IAIK;

import iaik.utils.*;
import iaik.utils.CryptoUtils;
import iaik.security.provider.IAIK;
import iaik.security.rsa.*;
import java.security.*;
import java.security.spec.*;
//import java.security.interfaces.*;
import javax.crypto.*;
import javax.crypto.spec.*;
//import javax.crypto.interfaces.*;
//import iaik.pkcs.pkcs8.*;
import iaik.security.cipher.PBEKey;


public class Cript {
	
	public static void generaRSA(String pukey,String prkey) throws Exception{
		
		
			RSAKeyPairGenerator KpairGen = (RSAKeyPairGenerator) KeyPairGenerator.getInstance("RSA");
 			
 			KpairGen.initialize(1024,new SecureRandom());
			
			System.out.println("Genero");
			KeyPair Kpair = KpairGen.generateKeyPair();
			
			RSAPublicKey PuKey = (RSAPublicKey) Kpair.getPublic();
			RSAPrivateKey PrKey = (RSAPrivateKey) Kpair.getPrivate();
			
			
			
			FileOutputStream ostream1 = new FileOutputStream(pukey+".puk");
			FileOutputStream ostream2 = new FileOutputStream(prkey+".prk");
			ObjectOutputStream p1 = new ObjectOutputStream(ostream1);
			p1.writeObject(PuKey);
			
			p1.flush();
			ostream1.close();
			System.out.println("Chiave Pubblica "+pukey+".puk salvata");
			
			
			ObjectOutputStream p2 = new ObjectOutputStream(ostream2);
			
			p2.writeObject(PrKey);
			
			p2.flush();
			ostream2.close();	
			System.out.println("Chiave Privata "+prkey+".prk salvata");
	}

	
	
	public static byte[] decripta(byte[] b,SecretKey Deskey) {
		
		try {	
			//System.out.println("leggiDesCriptato 3 lunghezza b : "+java.lang.reflect.Array.getLength(b));
                       		Cipher des1 = Cipher.getInstance("DES", "IAIK");
			//System.out.println("leggiDesCriptato 4");
			des1.init(Cipher.DECRYPT_MODE,Deskey);
			//System.out.println("leggiDesCriptato 5");
			return des1.doFinal(b);
		} catch(Exception e) {
			System.out.println("Des decripta error "+e.getMessage());
			return null;
		}
		
	}
	
	public static byte[] cripta(byte[] b,String pass) {
		try {
			
 			// salt, 8 bytes long
			byte[] salt =  {(byte)0xcc,(byte)0x91,(byte)0x73,(byte)0x2b,
					(byte)0x80,(byte)0x22,(byte)0xf6,(byte)0x84};
 			//iteration count
 			int count = 1;
 			// PBE paramters
 			PBEParameterSpec pbeParamSpec = new PBEParameterSpec(salt, count);
 			// PBEKey from password
 			PBEKey pbeKey = new PBEKey(pass);
 			Cipher pbeCipher = Cipher.getInstance("PbeWithMD5AndDES_CBC");
 			// initialize for encryption
 			pbeCipher.init(Cipher.ENCRYPT_MODE, pbeKey, pbeParamSpec);
 			// encrypt data
 			byte[] encrypted = pbeCipher.doFinal(b);
 			
			
			return encrypted;
		}catch(Exception e) {
			System.out.println("errore cripta : "+e.getMessage());
			return null;	
		}
		
	
	}
	public static byte[] decripta(byte[] b,String pass) {
		try {
			
			// salt, 8 bytes long
			byte[] salt =  {(byte)0xcc,(byte)0x91,(byte)0x73,(byte)0x2b,
					(byte)0x80,(byte)0x22,(byte)0xf6,(byte)0x84};
 			//iteration count
 			int count = 1;
 			// PBE paramters
 			PBEParameterSpec pbeParamSpec = new PBEParameterSpec(salt, count);
 			// PBEKey from password
 			PBEKey pbeKey = new PBEKey(pass);
 			Cipher pbeCipher = Cipher.getInstance("PbeWithMD5AndDES_CBC");
 			
 			// initialize for decryption
 			pbeCipher.init(Cipher.DECRYPT_MODE, pbeKey, pbeParamSpec);
 			// decrypt cipher data
 			byte[] decrypted = pbeCipher.doFinal(b);
 
			
			return decrypted;
		}catch(Exception e) {
			System.out.println("errore decripta : "+e.getMessage());
			return null;	
		}
		
	}
	public static byte[] cripta(byte[] b,SecretKey Deskey) {
		
		try {	
			
                        Cipher rsa = Cipher.getInstance("RSA");
                        
                       
			
			int lendati = java.lang.reflect.Array.getLength(b);
	      		Cipher des = Cipher.getInstance("DES", "IAIK");
			int lenblocco = des.getBlockSize();
			//System.out.println("lung blocco : "+lenblocco);
			int numblocchi = lendati / lenblocco;
			if ((lendati % lenblocco)>0) numblocchi++;
			//System.out.println("numero blocchi : "+numblocchi);
			int lunarr = numblocchi * lenblocco;
			byte[] dati = new byte[lunarr];
			CryptoUtils.zeroBlock(dati);
			CryptoUtils.copyBlock(b,dati);
			des.init(Cipher.ENCRYPT_MODE,Deskey);
			return des.doFinal(dati);	
		} catch(Exception e) {
			System.out.println("Des cripta error "+e.getMessage());
			return null; 
		}
	}
			
                
                        
	
	public static byte[] decripta(byte[] b,RSAPrivateKey prk) {
		
		try {	
			
			
			ByteArrayInputStream buftemp = new ByteArrayInputStream(b);
	      		ObjectInputStream datatemp = new ObjectInputStream(buftemp);
                        
                        ByteArrayOutputStream buftempout = new ByteArrayOutputStream();
                        Cipher rsa = Cipher.getInstance("RSA");
			
			rsa.init(Cipher.DECRYPT_MODE,prk);
			byte[] data;
			
			try {
				while(true) {
			
					data = (byte[]) datatemp.readObject();
			
					byte[] cleartext = rsa.doFinal(data);
			
					int len1 = java.lang.reflect.Array.getLength(cleartext);
			
					buftempout.write(cleartext,0,len1);
					
				}				
			} catch(Exception e) {
				//System.out.println("9");
			}
			
			return buftempout.toByteArray();
			
		} catch(Exception e) {
			System.out.println("RSAdecripta error "+e.getMessage());
			if(prk == null) System.out.println("errore chiave privata nulla");
			return null;
		}	
		
	}

	public static byte[] cripta(byte[] b,RSAPublicKey puk) {

	
      		int lenb =java.lang.reflect.Array.getLength(b);
      		//System.out.println("cripta 1 lung : "+lenb);
      		try {	
	      		Cipher rsa = Cipher.getInstance("RSA");
	      		rsa.init(Cipher.ENCRYPT_MODE,puk);
	      		//System.out.println("cripta 2 key : "+puk);
	      		
	      		ByteArrayOutputStream buftemp = new ByteArrayOutputStream();
	      		ObjectOutputStream datatemp = new ObjectOutputStream(buftemp);
	      		//System.out.println("cripta 3");
	      		for(int i=0;i<lenb;i=i+100) {
				int len1=(i+100<lenb) ? 100 : lenb-i;
				byte[] ciphertext = rsa.doFinal(b,i,len1);
				int len2 = java.lang.reflect.Array.getLength(ciphertext);
				
				
				datatemp.writeObject(ciphertext);
			}
			datatemp.flush();
			return buftemp.toByteArray();
			
	      	} catch(Exception e) {
	      		System.out.println("cripta Error "+e.getMessage());
	      		return null;
	      		
	      	}

	}
	public static byte[] decripta(byte[] b,RSAPublicKey prk) {
		
		try {	
			
			
			ByteArrayInputStream buftemp = new ByteArrayInputStream(b);
	      		ObjectInputStream datatemp = new ObjectInputStream(buftemp);
                        
                        ByteArrayOutputStream buftempout = new ByteArrayOutputStream();
                        Cipher rsa = Cipher.getInstance("RSA");
			
			rsa.init(Cipher.DECRYPT_MODE,prk);
			byte[] data;
			
			try {
				while(true) {
			
					data = (byte[]) datatemp.readObject();
			
					byte[] cleartext = rsa.doFinal(data);
			
					int len1 = java.lang.reflect.Array.getLength(cleartext);
			
					buftempout.write(cleartext,0,len1);
					
				}				
			} catch(Exception e) {
				//System.out.println("9");
			}
			
			return buftempout.toByteArray();
			
		} catch(Exception e) {
			System.out.println("RSAdecripta error "+e.getMessage());
			if(prk == null) System.out.println("errore chiave privata nulla");
			return null;
		}	
		
	}

	public static byte[] cripta(byte[] b,RSAPrivateKey puk) { 

	
      		int lenb =java.lang.reflect.Array.getLength(b);
      		//System.out.println("cripta 1 lung : "+lenb);
      		try {	
	      		Cipher rsa = Cipher.getInstance("RSA");
	      		rsa.init(Cipher.ENCRYPT_MODE,puk);
	      		//System.out.println("cripta 2 key : "+puk);
	      		
	      		ByteArrayOutputStream buftemp = new ByteArrayOutputStream();
	      		ObjectOutputStream datatemp = new ObjectOutputStream(buftemp);
	      		//System.out.println("cripta 3");
	      		for(int i=0;i<lenb;i=i+100) {
				int len1=(i+100<lenb) ? 100 : lenb-i;
				byte[] ciphertext = rsa.doFinal(b,i,len1);
				int len2 = java.lang.reflect.Array.getLength(ciphertext);
				
				
				datatemp.writeObject(ciphertext);
			}
			datatemp.flush();
			return buftemp.toByteArray();
			
	      	} catch(Exception e) {
	      		System.out.println("cripta Error "+e.getMessage());
	      		return null;
	      		
	      	}

	}
	public static void stampa(SecretKey sk) {
			
		try {
			System.out.println("Inizio stampa chiave");
			byte[] by = ObjToByte(sk);
			String j = toHexString(by);
			System.out.println(j);
			
			
			System.out.println("Fine stampa chiave");
		} catch(Exception e) {
			System.out.println("Stampa chiave fallita"+e.getMessage());
		}
		
		
	}
	public static void stampa(byte[] by) {
			
		try {
			System.out.println("Inizio stampa byte");
			
			String j = toHexString(by);
			System.out.println(j);
			
			
			System.out.println("Fine stampa byte");
		} catch(Exception e) {
			System.out.println("Stampa byte fallita"+e.getMessage());
		}
		
		
	}
	public static Object ByteToObj(byte[] in) throws Exception{  //metti private
		
		ByteArrayInputStream bais = new ByteArrayInputStream(in);
		ObjectInputStream p = new ObjectInputStream(bais);
		Object obj = p.readObject();
	
		bais.close();
		return obj;
	}
 	
 	public static byte[] ObjToByte(Object obj) throws Exception{   //metti private
 	//public void ObjToByte(Object obj) throws Exception{   //metti private
	 	ByteArrayOutputStream baos = new ByteArrayOutputStream();
		ObjectOutputStream p = new ObjectOutputStream(baos);
		p.writeObject(obj);
		byte[] b = baos.toByteArray();
		
		baos.close();
		return b;
	}
	private static String toHexString(byte[] block) {
		StringBuffer buf = new StringBuffer();
		
		int len = block.length;
		
		for (int i = 0; i < len; i++) {
			byte2hex(block[i], buf);
			if (i < len-1) {
				//buf.append(":");
			}
		} 
		return buf.toString();
	}
	private static void byte2hex(byte b, StringBuffer buf) {
		char[] hexChars = { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F' };
		int high = ((b & 0xf0) >> 4);
		int low = (b & 0x0f);
		buf.append(hexChars[high]);
		buf.append(hexChars[low]);
	}
}