

import java.io.*;
import java.util.*;

import iaik.security.rsa.*;
import java.security.*;
import java.security.spec.*;

import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;

public final class Firma implements Serializable{
	
	private java.lang.Long milli;
	private byte[] firma;
	//private byte[] mdhash;
	private String from;
	private String to;
	
	
	public Firma() {
		firma = null;
		//mdhash = null;
		from = null;
		to = null;
	
	}
	
	public boolean verifica(RSAPublicKey puk) {
		try {
			//boolean risp;
			Signature md5rsa = Signature.getInstance("MD5/RSA", "IAIK");
			md5rsa.initVerify(puk);
			//byte[] data = new byte[1024];
			md5rsa.update(from.getBytes());
			md5rsa.update(to.getBytes());
			md5rsa.update(milli.byteValue());
			return md5rsa.verify(firma);
			/*
			MessageDigest md5 = MessageDigest.getInstance("MD5");
			md5.update(from.getBytes());
			md5.update(to.getBytes());
			md5.update(milli.byteValue());
			md5.update(firma);
			byte[] mdhash1 = md5.digest();
			risp &= java.security.MessageDigest.isEqual(mdhash,mdhash1);
			*/
			//return risp;	
			
		}
		catch(Exception e) {
			System.out.println("Errore verifica firma "+e.getMessage());
			return false;
		}
	}
	
	public void crea (RSAPrivateKey prkey,String f,String t) {
		try {
			milli = new java.lang.Long(java.lang.System.currentTimeMillis());
			from = f;
			to = t;
			//Random random = new Random();
		  	//byte[] data = new byte[1024];
		  	//random.nextBytes(data);
			Signature md5rsa = Signature.getInstance("MD5/RSA", "IAIK");
			md5rsa.initSign(prkey);
			md5rsa.update(from.getBytes());
			md5rsa.update(to.getBytes());
			md5rsa.update(milli.byteValue());
			firma = md5rsa.sign();
			
			
			
		}
		catch(Exception e) { 
			System.out.println("Errore crea firma "+e.getMessage());
		
		}
	
	}
	
	public long getData() {
		return milli.longValue();
	}
	
	public String getUser() {
		return from;
	}
	public String getTo() {
		return to;
	}
	

		
}