package servizi;

import java.sql.*;
import java.net.*;
import java.io.*;
import java.awt.*;

import java.util.*;
import iaik.security.rsa.*;
import java.security.*;
import java.security.spec.*;


import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;



import Gestore_Connessione;
import ServiceHash;
import Cache;
import Ticket;
import Connessione;
import Cript;
import MyCertificate;


public class ServClient extends Servizio {
	//private String user;
	//private String server;
	//private String server1;
	//private String rDominio;
	private byte[] msg;
	//private Ticket t;
	//private boolean presente;
	public ServClient() {
		super();
		//user = "";
		//server = "";
		//server1 = "";
		//presente = false;
		descrizione = "Servizi Client";
		nome = "ServClient";
		servTerm = new String[7];
		servTerm[0] = "richiedi ,dom nome server pass,  richiesta di sessione con dominio dom"; 
		servTerm[1] = "connetti , user@server,  connessione nuovo user"; 
		servTerm[2] = "sconnetti , user,  termine connessione"; 
		servTerm[3] = "accedi , dom ,  richiesta di sessione con dominio dom"; 
		servTerm[4] = "dom , comando ,  invia un comando al server di dominio autenticato"; 
		servTerm[5] = "user, , visualizza utente connesso"; 
		servTerm[6] = "rDom, , visualizza dominio remoto"; 
	}
	//metti a posto gli eventi
	public String risposta(String nomeserv,Object arg) {
		return null;
	}	
	
	public String rispostaTerminale(String nomeserv,String arg) {
		String user = (String) gest.memGet(nome,"user");
		String server = (String) gest.memGet(nome,"server");
		String server1 = (String) gest.memGet(nome,"server1");
		String rDominio = (String) gest.memGet(nome,"rDominio");
		Ticket t = (Ticket) gest.memGet(nome,"Ticket");
		
		if(nomeserv.equals("user")) {
			if(user == null) {
				System.out.println("UtenteNonSpec");
				return "UtenteNonSpec";
			}
			if(server == null) {
				System.out.println("ServerNonSpec");
				return "ServerNonSpec";
			}
			System.out.println(user+"@"+server);
			return "UtenteVisualizzato";
		}
		if(nomeserv.equals("rDom")) {
			if(rDominio == null) {
				System.out.println("RemoteDominioNonSpec");
				return "RemoteDominioNonSpec";
			}
			if(server1 == null) {
				System.out.println("RemoteServerNonSpec");
				return "RemoteServerNonSpec";
			}
			System.out.println(rDominio+" ["+server+"]");
			return "RemoteDominioVisualizzato";
		}
		if(nomeserv.equals("richiedi")) {
			if(arg!=null) {
				
				String aa = (String) arg;
				String domx;
				String userx;
				String serverx;
				String passx;
				int pos = aa.trim().indexOf(" ");
				if(pos == -1) {
					return "DominioNonSpec";
				} else {	domx = aa.substring(0,pos);
					aa = aa.substring(pos+1);
					pos = aa.trim().indexOf(" ");
					if(pos == -1) {
					return "UtenteNonSpec";
					} else { 	userx = aa.substring(0,pos);
						aa = aa.substring(pos+1);
						pos = aa.trim().indexOf(" ");
						if(pos == -1) {
						return "ServerNonSpec";
						} else {
							serverx = aa.substring(0,pos);
							passx = aa.substring(pos+1);
							return accediTot(domx,userx,serverx,passx);
						}
					}
				}
								
			} else {
				return "NonHoArgomenti";
			}
			
		}
		
		if(nomeserv.equals("connetti")) {
			gest.memRst(nome);
			try {
				String aa = (String) arg;
				int pos = aa.trim().indexOf("@");
				if(pos == -1) {
					return "ServerNonSpec";
				} else {	
					String userx = aa.substring(0,pos);
					String serverx = aa.substring(pos+1);
					gest.memPut(userx,nome,"user");
					gest.memPut(serverx,nome,"server");		
					return "Connesso";
				}
			} catch(Exception e) {
				return "ArgomentiErrati";
			}
			
			
			
		}
		if(nomeserv.equals("sconnetti")) {
			gest.memRst(nome);
			return "Sconnesso";
		}
		if(nomeserv.equals("accedi")) {
			String dom = (String) arg;
			if(user == null) {
				return "UtenteNonSpec";
			}
			if(server == null) {
				return "ServerNonSpec";
			}
			return accedi(dom,user,server);
		}
		if(nomeserv.equals("dom")) {
			String com = (String) arg;
			if(user == null) {
				return "UtenteNonSpec";
			}
			if(server == null) {
				return "ServerNonSpec";
			}
			if(server1 == null) {
				return "ServerDominioNonSpec";
			}
			if(t == null) {
				return "TicketNonTrovato";
			}
			return comunica(com,user,server,server1,t);
			
			
		}
		
		return null;
	
	}		
	private String ottieniTic(String dom,String user,String server) {
		try {
			Connessione con = new Connessione(gest.getMe());
			if(gestRic.attiva("Conn",server,con).startsWith("Attivata-")) {
				con.manda("UsLog");
				con.manda(dom);
				con.manda(user);
				con.mandachiaro();
				con.leggicriptato();
				String a = (String) con.leggi();
				String b = (String) con.leggi();
				String c = null;
				if(gest.verbose) System.out.println("ricevuta risposta accesso "+a+"-"+b);
				if(a.equals("Respo")) {
					msg = (byte[]) con.leggi();
					//server1 = b;
					//rDominio = dom;
					//presente = true;
					gest.memPut(b,nome,"server1");
					gest.memPut(dom,nome,"rDominio");
					return "Ottenuto";
			} else {
					c = (String) con.leggi();
					System.out.println(a.toString()+":"+b.toString());
					gest.memRst(nome);
					return "Rifiutata";
				}
			} else return "ConnNonAttiva";
		} catch (Exception e) {
			System.out.println("Errore in ottieniTic"+e.getMessage());
			return "Errore";
		}
	}
	private String accedi(String dom,String user,String server) {
		String res = ottieniTic(dom,user,server);
			if (!res.equals("Ottenuto")) {
				gest.memPut("",nome,"server1");
				return res;
			}
			String pass;
			try {
				System.out.flush();
				System.out.print("password > ");
				System.out.flush();
				BufferedReader keyboardInput = new BufferedReader(new InputStreamReader(System.in));
				pass=keyboardInput.readLine();
			}
			catch (Exception e){
				System.out.println("ErrorePassword");
				return "ErrorePassword";	
			}
			byte[] msgc = Cript.decripta(msg,pass);
			pass="";
			if(msgc != null) {
				Ticket t = new Ticket();
				t.setMessaggio(msgc);
				gest.memPut(t,nome,"Ticket");
				if(gest.verbose) System.out.println(t.getOra()+":"+t.getValidita());
				return "AutenticazioneEffettuata";
			} else {
				if(gest.verbose) System.out.println("PasswordNonRiconosciuta");
				return "PasswordNonRiconosciuta";
			}
					
	}
	private String comunica(String com,String user,String server,String server1,Ticket t) {
		if(gest.verbose) System.out.println("validita ticket : "+t.getValidita());
		Connessione con1 = new Connessione(gest.getMe());
		Object[] aaa = new Object[2];
		aaa[0] = t.getKsessiontgs();
		aaa[1] = server1;
		if(!gestRic.attiva("DesConn",aaa,con1).startsWith("Attivata-")) 
			return "NonConnesso";
		con1.manda(t.getTicket());
		con1.manda(user);
		con1.manda(com);
		con1.mandaDesCriptato();
		con1.leggiDesCriptato();
		//Cript.stampa(t.getKsessiontgs());
		try {
			String a1 = (String) con1.leggi();
			String b1 = (String) con1.leggi();
			String c1 = (String) con1.leggi();
			System.out.println(a1+":\n"+b1+"\n:"+c1);
			return "accettata";		
		} catch (Exception e) {
			return "rispostaNonValida";		
		}
		
	}
	// ripristina prevede serializzazione anche di oggetti
	public void inizializza(Gestore_Connessione g,ServiceHash sh) {
		// da ridefinire se la serializzazione prevede cose particolari
		inizializza_p(g,sh);
		
	}
	public void prepTrasporto() {
		azzera_p();
		//nt_dom_cache = null;
		
		
	}
	public void riprTrasporto(Gestore_Connessione g,ServiceHash sh) {
		// serve per ripristinare il Servizio dal trasporto
		// da ridefinire se il ripristino prevede cose particolari
		inizializza_p(g,sh);
		//metto a posto : passa da slave a master
		
		
	}
	public void azzera() {
		// da ridefinire se la serializzazione prevede cose particolari
		azzera_p();
		
	
	}	
/*		System.out.print(gest.getMe()+" > ");
		System.out.flush();
		String command;
		
		BufferedReader keyboardInput = new BufferedReader(new InputStreamReader(System.in));
		
		command=keyboardInput.readLine();
*/	
	
	private String accediTot(String dom,String user,String server,String pass) {
		Connessione con = new Connessione(gest.getMe());
		if(gestRic.attiva("Conn",server,con).startsWith("Attivata-")) {
			con.manda("UsLog");
			con.manda(dom);
			con.manda(user);
			con.mandachiaro();
			con.leggicriptato();
			String a = (String) con.leggi();
			String b = (String) con.leggi();
			String c = null;
			byte[] msg;
			if(gest.verbose) System.out.println("ricevuta risposta accesso "+a+"-"+b);
			if(a.equals("Respo")) {
				
				msg = (byte[]) con.leggi();
				msg = Cript.decripta(msg,pass);
				Ticket t = new Ticket();
				t.setMessaggio(msg);
				
				if(gest.verbose) System.out.println(t.getOra()+":"+t.getValidita());
				
				//for(int o = 0 ; o<100000;o++) ;
				Connessione con1 = new Connessione(gest.getMe());
				Object[] aaa = new Object[2];
				aaa[0] = t.getKsessiontgs();
				aaa[1] = b;
				if(!gestRic.attiva("DesConn",aaa,con1).startsWith("Attivata-")) 
					return "NonTcg";
				con1.manda(t.getTicket());
				con1.manda(user);
				con1.manda("ciao");
				con1.mandaDesCriptato();
				con1.leggiDesCriptato();
				//Cript.stampa(t.getKsessiontgs());
				String a1 = (String) con1.leggi();
				
				String b1 = (String) con1.leggi();
				String c1 = (String) con1.leggi();
				System.out.println(a1+":"+b1+":"+c1);
				return "accettata";
				
			} else {
				c = (String) con.leggi();
				System.out.println(a.toString()+":"+b.toString());
				return "Rifiutata";
			}
		} else return "ConnNonAttiva";
	}
	
	
}