import java.util.*;

public class Tempo {

	private Calendar r;
	private int mil_MAX; /* 90061000 */
	private int sec_MAX; /* 32144460 */
	private boolean vuoto;
	private int msec;
	private int sec;
	private int min;
	private int hour;
	private int day;
	private int week;
	private int month; 
        private int year;  
	
	public Tempo() {
	
		this.r = Calendar.getInstance();
		this.vuoto = true;
		this.sec_MAX = 60+60*(60+60*(24+24*(7+7*52)));
		this.mil_MAX = 1000+1000*(60+60*(60+60*24));
	
	}
	private void inizio(){
		msec = r.get(Calendar.MILLISECOND);
		sec = r.get(Calendar.SECOND);
		min = r.get(Calendar.MINUTE);
		hour = r.get(Calendar.HOUR_OF_DAY);
		day = r.get(Calendar.DAY_OF_MONTH);
		week = r.get(Calendar.WEEK_OF_YEAR);
		month = r.get(Calendar.MONTH); 
	        year = r.get(Calendar.YEAR); 
		vuoto = false;	
	
	}
	
	public int mil_max() {
		return mil_MAX;
	}
	public int sec_max() {
		return sec_MAX;
	}
	public String get_time() {
		
		if(vuoto) inizio();
		return new String(""+year+":"+month+":"+day+":"+hour+":"+min+":"+sec+":"+msec);
	
		/* msec+1000*(sec+60*(min+60*(hour+24*(day+7*week)))); */
	}
	
	public int mil_ora() { //restituisce il numero in millisecondi del momento attuale nell 'anno
		
		if(vuoto) inizio();
		
		return msec+1000*(sec+60*(min+60*hour));
	
		/* msec+1000*(sec+60*(min+60*(hour+24*(day+7*week)))); */
	}
	public int sec_ora() { //restituisce il numero in secondi del momento attuale nell 'anno
		
		
		if(vuoto) inizio();
		return sec+60*(min+60*(hour+24*(day+7*week)));
	
		 
	}
	public String getData() {
		return ""+year+":"+month+":"+day;	
		
	}
}