package servizi;

import java.sql.*;
import java.net.*;
import java.io.*;
import java.awt.*;

import java.util.*;
import iaik.security.rsa.*;
import java.security.*;
import java.security.spec.*;


import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;
import Connessione;
import Firma;


public class InviaServ extends Servizio {
		
	public InviaServ() {
		super();
		descrizione = "Servizi di invio remoto dei servizi";
		nome = "InviaServ";
		servizi = new String[4];
		servizi[0] = "InvSer";
		servizi[1] = "RicSer";
		servizi[2] = "InvAge";
		servizi[3] = "RicAge";
		servTerm = new String[1];
		servTerm[0] = "InvSer , <server> <servizio>,invia allo slave server il servizio";
		
	}
	
	public String risposta(String nomeserv,Object arg) {
//		System.out.println("RiceviServizio1 connesso "+connesso+" firmato "+firmato);
		if((nomeserv.equals("InvSer")|| nomeserv.equals("InvAge"))&&!connesso) { 
			//String nomi = nomeserv.substring(7).trim();
			if(argomenti) {
				try {
					String aa = (String) arg;
					int pos = aa.trim().indexOf(" ");
					String addr;
					String serv;
					if(pos == -1) {
						return "ServerNonSpec";
					} else {
						addr = aa.substring(0,pos);
						serv = aa.substring(pos+1);
						
					}
					if(nomeserv.equals("InvAge")) {
						return inviaServizio(addr,serv,true);
					} else {
						return inviaServizio(addr,serv,false);
					}
					
				} catch(Exception e) {
					try {
						Object[] obl = (Object[]) arg;
						Connessione con = (Connessione) obl[0];
						Servizio ser = (Servizio) obl[1];
						if(nomeserv.equals("InvAge")) {
							return inviaServizio(con,ser,true);
						} else {
							return inviaServizio(con,ser,false);
							
						}
					} catch(Exception e1) {
						try {
							Object[] obl = (Object[]) arg;
							String server = (String) obl[0];
							Servizio ser = (Servizio) obl[1];
							if(nomeserv.equals("InvAge")) {
								return inviaServizio(server,ser,true);
							} else {
								return inviaServizio(server,ser,false);
							}
						} catch(Exception e2) {
						
							return "ArgomentiErrati";
						}
					}
					
				}
			} else {
				return "NonHoArgomenti";
			}
		}
		if((nomeserv.equals("RicSer")|| nomeserv.equals("RicAge"))&&connesso&&firmato) { 
//			System.out.println("RiceviServizio1");
			Firma fir = mySock.getFirma();	
			
			if(!(gestRic.attiva("verificaFirma",fir,null).startsWith("Valida-")))
				return "FirmaNonValida";
			
			
			//mysock.inizio((RSAPublicKey) pkey.get(fir.getUser()));
			//System.out.println("RiceviServizio2");
			Servizio ser;
			try {
				ser = (Servizio) mySock.leggi();
			}
			catch (Exception e){
				ser=null;
			}
			if(ser == null )  { return "ServNonRic"; }
			else {
				if(nomeserv.equals("RicAge")) return riceviServizio(ser,true);
				else return riceviServizio(ser,false);
			}
	
		}
		return "-0";
	}
	public String rispostaTerminale(String nomeserv,String arg) {
		if(nomeserv.equals("InvSer")) { 
			//String nomi = nomeserv.substring(7).trim();
			if(arg!=null) {
				
				String aa = (String) arg;
				int pos = aa.trim().indexOf(" ");
				String addr;
				String serv;
				if(pos == -1) {
					return "ServerNonSpec";
				} else {
					addr = aa.substring(0,pos);
					serv = aa.substring(pos+1);
					
				}
				return inviaServizio(addr,serv,false);
				
			} else {
				return "NonHoArgomenti";
			}
		}
		return null;
	}
	private String inviaServizio(String server,String nomser,boolean ag) {
		Servizio sv = servHash.richiediServ(nomser);
		if(sv==null) {
			System.out.println("servizio non trovato"); //togli
			return "ServNonTrovato";
			
		}
		Servizio sv1 = sv.mioClone();
		if(sv1!=null) {
			sv1.azzera();
			return inviaServizio(server,sv1,ag);
		}
		else return "ServNullo";
		
	}
	
	private String inviaServizio(String server,Servizio ser,boolean ag) {
		System.out.println("inviaServizio a"+server);
			Connessione con = new Connessione(gest.getMe());
			if(gestRic.attiva("Conn",server,con).startsWith("Attivata-"))
				return inviaServizio(con,ser,ag);
			else return "ConnNonAtt";
		
		}	
	private String inviaServizio(Connessione con,Servizio ser,boolean ag) {		
		System.out.println("inviaServizio");
		try{				
			if(con.stato()) {
				System.out.println("invia servizio connessione attiva "); //togli
				con.firma(gest.getMe());
				if(ag) con.manda("RicAge");	
				else con.manda("RicSer");	
				con.manda(ser);
				con.mandacriptato();
				//con.mandachiaro();
				if(con.stato()) {
					con.leggicriptato();
					//Object l = con.leggi();
					String ok = (String) con.leggi();
					System.out.println("ok :"+ok); //togli
					try {
						//String ok = (String) l;
						if(ok.equals("Ricevuto")) {
							System.out.println("invia servizio inviato dice:"+ok); //togli
							return "Inviato-"+ser.nome();
							
						}
						else {
							System.out.println("invia servizio inviato dice non ok"+ok); //togli
							return "NonInviato";
						}
					} catch(Exception e) {
						System.out.println("invia servizio inviato dice eccezione "+e.getMessage()); //togli
						return "NonInviato";
					}
				}else {
					System.out.println("invia servizio inviato dice stato non attivo"); //togli
					return "NonInviato";
				}
				
				
			} else return "ConnNonAtt";
			
		} catch(Exception e) {
			System.out.println("error inviaServizio "+e.getMessage());
			return "-1";
		}
       	
	}
	private synchronized String riceviServizio(Servizio ser,boolean ag)  {
		
	        //System.out.println("The class of " + ser +" is " + ser.getClass().getName());
     		//ser.getClass()
		String ric = new String("Ricevuto");
		mySock.manda(ric);
		//mySock.mandacriptato();
		mySock.mandachiaro();
		if(ag) servHash.registraAgent(ser);
		else servHash.registra(ser);
		return ric;
       		
       	}
       	
	
	
}