package servizi;

import java.sql.*;
import java.net.*;
import java.io.*;
import java.awt.*;

import java.util.*;
import iaik.security.rsa.*;
import java.security.*;
import java.security.spec.*;


import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;



import Gestore_Connessione;
import ServiceHash;
import Cache;
import Ticket;
import Tempo;
import Connessione;
import Cript;
import MyCertificate;


public class ServAut extends Servizio implements Serializable {
//	private final int Dominio_non_Trovato = 0;
//	private final int User_non_Riconosciuto = 1;
//	private final int User_Disabilitato = 2;
//	private final int User_Bloccato = 3;
		
	private Hashtable utentiPass; /*  memorizzati come chiave con valore come risposta  */
	private RSAPublicKey scgpuk;
	//private String dominio;
	private String ServerTicket;
	private int mil_ntrovato;
	private int mil_nabilitati;
	private int mil_bloccati;
	private int mil_nriconosciuti;
	private int sec_valticket;
	private Cache nt_dom_cache; /*  domini non trovati */
	private Cache na_usr_cache; /*  utenti non abilitati per il remoto registrati come dom:user  */
	private Cache nr_usr_cache; /*  utenti non riconosciuti per il remoto registrati come dom:user  */
	private Cache b_cache; /*  utenti locali (chiave) bloccati con motivo come risposta  */
	
	//private TickTable ticktable; //cambia
	
	
	
	public ServAut() {
		super();
		
		descrizione = "Servizi di Autenticazione";
		nome = "ServAut";
		servizi = new String[2];
		servizi[0] = "Login";
		servizi[1] = "UsLog";
		servTerm = new String[9];
		servTerm[0] = "utenti ,, mostra utenti"; 
		servTerm[1] = "dominio ,, mostra il dominio di lavoro"; 
		servTerm[2] = "ServerTicket ,, mostra l' indirizzo del server ServerTicket che amministra";
		servTerm[3] = "creaUtente , nome password, aggiunge utente"; 
		servTerm[4] = "cancellaUtente , nome , cancella utente"; 
		servTerm[5] = "salvaUtenti , nome, salva file password utente";
		servTerm[6] = "bloccaUtente , nome , aggiunge utente alla lista degli utenti bloccati"; 
		servTerm[7] = "sbloccaUtente , nome , toglie utente dalla lista degli utenti bloccati"; 
		servTerm[8] = "utentiBloccati ,, mostra utenti bloccati"; 
		//servTerm[5] = "prova ,dom nome server pass, prova"; 
		//servTerm[5] = "cripto ,, "; 
	}
	//metti a posto gli eventi
	public String risposta(String nomeserv,Object arg) {
		//System.out.println("xxx"+firmato);
		
		// richiesta da client (remoto)
		if(nomeserv.equals("UsLog")&&connesso) { 
			if(gest.verbose) System.out.println("risposta al login verifico");
			return verifico();
			
		}
		if(nomeserv.equals("Login")&&connesso&&firmato) { 
			if(gest.verbose) System.out.println("risposta al login verifico REmoto");
			return verificoRemoto();
			
		}
		
			
		
		return "0";
	}	
	
	public String rispostaTerminale(String nomeserv,String arg) {
		if(nomeserv.equals("ServerTicket")) {
			return ServerTicket;
			
			
		}
		if(nomeserv.equals("cripto")) {
			
			String aaa = "uno";
			byte[] pr = aaa.getBytes();
			byte[] e = Cript.cripta(pr,"pass");
			byte[] d = Cript.decripta(e,"pass");
			if(gest.verbose) System.out.println("prova 0    : "+new String(pr));
			if(d !=null) System.out.println("decriptato : "+new String(d));
			
			aaa = "due";
			pr = aaa.getBytes();
			e = Cript.cripta(pr,"pass");
			d = Cript.decripta(e,"pass");
			System.out.println("prova 0    : "+new String(pr));
			if(d !=null) System.out.println("decriptato : "+new String(d));
			
			
		}
		if(nomeserv.equals("dominio")) {
			return gest.dominio();
		}
		if(nomeserv.equals("cancellaUtente")) { 
			if(arg!=null) {
				utentiPass.remove((String) arg);
				return "UtenteCancellato";
			} else {
				return "UtenteNonSpec";
			}
		}
		if(nomeserv.equals("utentiBloccati")) { 
			String ret = b_cache.stampa();
			if (ret.equals("")) return "NonHoUtentiBloccati";
			else return ret;
		}
		if(nomeserv.equals("sbloccaUtente")) { 
			if(arg!=null) {
				b_cache.delete((String) arg);
				return "UtenteSbloccato";
			} else {
				return "UtenteNonSpec";
			}			
		}
		if(nomeserv.equals("bloccaUtente")) { 
			if(arg!=null) {
				b_cache.permInsert((String) arg);
				return "UtenteBloccato";
			} else {
				return "UtenteNonSpec";
			}
		}
		if(nomeserv.equals("creaUtente")) { 
			//String nomi = nomeserv.substring(7).trim();
			if(arg!=null) {
				
				String aa = (String) arg;
				int pos = aa.trim().indexOf(" ");
				String nome;
				String pass;
				if(pos == -1) {
					return "UtenteNonSpec";
				} else {
					nome = aa.substring(0,pos);
					pass = aa.substring(pos+1);
					return creaUtente(nome,pass);
				}
								
			} else {
				return "NonHoArgomenti";
			}
		}
		if(nomeserv.equals("salvaUtenti")) { 
			if(arg!=null) {
				
				return salvaUtenti(arg);
				
								
			} else {
				return "NonHoArgomenti";
			}
		}
		if(nomeserv.equals("utenti")) {
			String ret = "";
			for (Enumeration e = utentiPass.keys() ; e.hasMoreElements() ;) {
				
	         		ret = ret.concat(((String)e.nextElement())+"\n");
	         		
	 		}
 			if(ret.equals("")) return "Non ho utenti";	
			else return ret;
		
		}
		return null;
	
	}		
	
	// ripristina prevede serializzazione anche di oggetti
	public void inizializza(Gestore_Connessione g,ServiceHash sh) {
		// da ridefinire se la serializzazione prevede cose particolari
		inizializza_p(g,sh);
	
		try {		
			mil_ntrovato = Integer.parseInt(gest.trova(nome+".domini non trovati msec"));
			
			mil_bloccati = Integer.parseInt(gest.trova(nome+".bloccati msec"));
			
			mil_nriconosciuti = Integer.parseInt(gest.trova(nome+".non riconosciuti msec"));
			
			mil_nabilitati = Integer.parseInt(gest.trova(nome+".non abilitati msec"));
			
			sec_valticket = Integer.parseInt(gest.trova(nome+".validita ticket sec"));
						
			nt_dom_cache = new Cache(mil_ntrovato);
			
			na_usr_cache = new Cache(mil_nabilitati);
			
			nr_usr_cache = new Cache(mil_nriconosciuti);
			
			//domini = new Hashtable();
			
			b_cache = new Cache(mil_bloccati);
			
					
			//dominio = gest.dominio();
			//System.out.println("dominio : "+dominio);
			//utenti = (Hashtable) gest.carica(nome+".file users");
			
			byte[] ooo = (byte[]) gest.carica(nome+".file users");
			if(ooo == null) {
				System.out.println("file utenti nuovo");
				utentiPass = new Hashtable();
			} else {	
				try {
					ooo = Cript.decripta(ooo,gest.getPublicKey());
					utentiPass = (Hashtable) Cript.ByteToObj(ooo);
					System.out.println("file utenti ripristinato");
				}
				catch(Exception e) {
					System.out.println("file utenti CORROTTO : ripristino vuoto");
					utentiPass = new Hashtable();
					iaik.utils.Util.waitKey();
					
				}
				
			}
			ServerTicket = gest.trova(nome+".SERVERTICKET");
			//System.out.println("ServerTicket : "+ServerTicket);
			MyCertificate sgccert = (MyCertificate) gest.carica(nome+".SERVERTICKETKEY");
			if(sgccert!=null) {
			
				//if(servHash.richiedi("verificaCertificato",sgccert,null).startsWith("Valido-"+ServerTicket))
				//	System.out.println("chiave scg valida "+sgccert.getAddress());
				//else System.out.println("chiave scg non valida "+sgccert.getAddress());
			
				scgpuk = (RSAPublicKey) sgccert.getPublicKey();
				
			}
			if(scgpuk == null) {
				if(gest.verbose) System.out.println("chiave scg non trovata");
				iaik.utils.Util.waitKey();	
			}	
			else if(gest.verbose) System.out.println("chiave scg caricata --------------------");
			
			
		} catch (Exception E) {
			System.out.println("configura : "+E.getMessage());
			iaik.utils.Util.waitKey();
		}
		
	}
	public void prepTrasporto() {
		azzera_p();
		//nt_dom_cache = null;
		na_usr_cache = null;
		nr_usr_cache = null;
		b_cache = null;
		mil_ntrovato = 0;
		mil_bloccati = 0;
		mil_nriconosciuti = 0;
		mil_nabilitati = 0;
		sec_valticket = 0;
		
		//dominio = null;
		utentiPass = null;
		
		ServerTicket = null;
		
		
	}
	public void riprTrasporto(Gestore_Connessione g,ServiceHash sh) {
		// serve per ripristinare il Servizio dal trasporto
		// da ridefinire se il ripristino prevede cose particolari
		inizializza_p(g,sh);
		//metto a posto : passa da slave a master
		
		
	}
	public void azzera() {
		// da ridefinire se la serializzazione prevede cose particolari
		azzera_p();
		mil_ntrovato = 0;
		mil_bloccati = 0;
		mil_nriconosciuti = 0;
		mil_nabilitati = 0;
		sec_valticket = 0;
		nt_dom_cache = null;
		na_usr_cache = null;
		nr_usr_cache = null;
		b_cache = null;
		
//		dominio = null;
		utentiPass = null;
		ServerTicket = null;
		
		utentiPass = null;
		scgpuk = null;
	//private String dominio;
		ServerTicket=null;
		
	
	}	
/*		
	private String getCache(int tipo,String val1,String val2) {
		
		return getCache(tipo,val1.concat(":"+val2));
		
	}
	
	private String getCache(int tipo,String val) {
		

		switch(tipo) {
			//case (Dominio_non_Trovato) : return (String) nt_dom_cache.get(val); //dominio non trovato	
			case (User_non_Riconosciuto) : return (String) nr_usr_cache.get(val);
			case (User_Disabilitato) : return (String) na_usr_cache.get(val);
			case (User_Bloccato) : return (String) b_cache.get(val);
		}

		return null;
			
	}
*/	
	private void processa(String a,String b,Object c,String dom,String user) {
		//System.out.println("Processa");
		/* processa la risposta per aggiornare le cache  */
		if(a.equals("Erro0")) ;
		if(a.equals("Erro1")) nr_usr_cache.insert(dom,user);
		if(a.equals("Erro2")) na_usr_cache.insert(dom,user);
		if(a.equals("Erro3")) b_cache.insert(dom,user);
		if(a.equals("Erro4")) ;
		if(a.equals("Erro5")) ;
		if(a.equals("Erro6")) ;
		//if(a.equals("Erro7")) nt_dom_cache.insert(dom);
			
	}
	private String verifico() {
		try {
			if(gest.verbose) System.out.println("verifico");
			String dom = (String) mySock.leggi();
			String user = (String) mySock.leggi();
			//String ip = (String) mySock.leggi();
			String ip = (String) mySock.remoteIp();
			Tempo t = new Tempo();
			String iniz = "" + t.mil_ora();
			//gest.memPut(iniz,"Conn",iniz);
			if(gest.verbose) System.out.println("verifico ok ip :"+ip+" dom "+dom+" user "+user);
			String pass = (String) utentiPass.get(user);
			if(pass == null) {
				mandaErrore("UtenteNonRegistrato");
				return "UtenteNonRegistrato";
			}
			if(dom.equals(gest.dominio())) return GetUserLogin(user,pass,ip);
			else return GetRemoteLogin(user,dom,pass,ip,iniz);
			
		} catch (Exception e) {
			if(gest.verbose) System.out.println("verifico error "+e.getMessage());
			mandaErrore("ArgomentiErrati");
			return "ArgomentiErrati";
			
		}	
		
	}
	private String verificoRemoto() {
		try {
			// verifica la firma
			if(gest.verbose) System.out.println("verificoRemoto");
			String dom = (String) mySock.leggi();
			String user = (String) mySock.leggi();
			String pass = (String) mySock.leggi();
			String ip = (String) mySock.leggi();
			String iniz = (String) mySock.leggi();
			if(gest.verbose) System.out.println("verificoRemoto "+dom+" "+user+" "+pass+" "+ip);
			/*
			if(iniz.equals(gest.getMe())) {
				mandaErrore("Loop");
				return "Loop";	
			}
			*/
			if(dom.equals(gest.dominio())) return GetUserLogin(user,pass,ip);
			else return GetRemoteLogin(user,dom,pass,ip,iniz);
			
		} catch (Exception e) {
			if(gest.verbose) System.out.println("verificoremoto error "+e.getMessage());
			mandaErrore("ArgomentiErrati");
			return "ArgomentiErrati";
			
		}	
		
	}

	private String GetUserLogin(String user,String pass,String ip) {
		if(gest.verbose) System.out.println("GetUserLogin ip :"+ip+" user "+user);
		String ret = verificoBlocchi(gest.dominio(),user);		
		if (!ret.equals("")) {
			mandaErrore(ret);
			System.out.println("XXXXXXXX "+ret);
			return ret;
		}
		
		Ticket tick = new Ticket();
		tick.creaTicket(scgpuk,user,mySock.remoteIp(),sec_valticket);		
		
		byte[] tickcrip = Cript.cripta(tick.getMessaggio(0),pass);
		//byte[] tickcrip = tick.getMessaggio(0);
		if(ServerTicket.equals(gest.getMe())) {
			if(gest.verbose) System.out.println("richiesta accesso locale di "+user);
			Object[] aaa = new Object[2];
			aaa[0] = (Object) tick.getTicket();
			aaa[1] = (Object) ip;
			if(gestRic.attiva("Inizio",aaa,null).startsWith("TicketAggiunto-")) {
				mySock.manda("Respo");	
				mySock.manda(ServerTicket);
				mySock.manda(tickcrip);
				mySock.mandachiaro();
				System.out.println("mandato ticket a "+user);
				return "Login-"+user;
			}else {
				mandaErrore("UtenteRifiutato");
				return "UtenteRifiutato";
			
			}
		}
		else{
			if(gest.verbose) System.out.println("richiesta accesso remoto di "+user);
			//Connessione consgc = new Connessione(gest.getMe());
			//if(servHash.richiedi("Conn",ServerTicket,consgc).startsWith("Attivata-")) {
			//Connessione consgc = new Connessione(ServerTicket,scgpuk, gest.getPrivateKey(),gest.getMe());
			Connessione consgc = new Connessione(gest.getMe());
			consgc.inizio(ServerTicket,scgpuk,gest.getPrivateKey());
			if(consgc.stato()) {
				if(gest.verbose) System.out.println("connessione a ServerTicket "+ServerTicket);
				consgc.manda("Inizio");
				consgc.manda(tick.getTicket());
				consgc.manda(ip);
				consgc.mandacriptato();
				if(gest.verbose) System.out.println("Attesa conferma ricezione di ticket ");
				consgc.leggicriptato();
				String res = (String) consgc.leggi();
				if(gest.verbose) System.out.println("Risposta "+res);
				if(res.equals("ok")) {
					mySock.manda("Respo");	
					mySock.manda(ServerTicket);
					mySock.manda(tickcrip);
					mySock.mandachiaro();
					return "Login-"+user;
				} else {
					mandaErrore("ComandoRifiutato");
					return "ComandoRifiutato";	
				}
			
			
			}			
			
			else {
				if(gest.verbose) System.out.println("ConnNonAtt"+ServerTicket);
				return "ConnNonAtt";
			}
			
		}	
		
			
		
		
		
	}	
	private String GetRemoteLogin(String user,String dom,String pass,String ip,String iniz) {
		if(gest.verbose) System.out.println("GetRemoteLogin");
		Object pr = gest.memGet(iniz,nome);
		if(pr!=null) {
			mandaErrore("Loop");
			gest.memRst(iniz);
			return "Loop";	
		}
		String ret = verificoBlocchi(dom,user);		
		if (!ret.equals("")) {
			mandaErrore(ret);
			return ret;
		}
	
		Connessione con = new Connessione(gest.getMe());
		if(!gestRic.attiva("ConnDominio",dom,con).startsWith("Attivata-")) {
				Connessione con1 = new Connessione(gest.getMe());
				if(!gestRic.attiva("ConnSuper",dom,con1).startsWith("Attivata-")) 
					{
						mandaErrore("ConnessioneFallita");
						return "ConnessioneFallita";
				}
				con = con1;
			}
		if(gest.verbose) System.out.println("GetRemoteLogin connessione a "+con.chi());
		//if(iniz.equals(con.chi())) {
		//	if(gest.verbose) System.out.println("Riscontrato Loop Errato");
		//	mandaErrore("Loop");
		//	return "Loop";
		//}
		gest.memPut(dom,iniz,nome);
		con.firma(gest.getMe());
		con.manda("Login");
		con.manda(dom);
		con.manda(user);
		con.manda(pass);
		con.manda(ip);
		con.manda(iniz);
		con.mandacriptato();
		con.leggicriptato();	
		Object a = con.leggi();
		Object b = con.leggi();
		Object c = con.leggi();
		if ((a==null) ||(b==null) ||(c==null)) {
			mandaErrore("RispostaErrata");
			gest.memRst(iniz);
			return "RispostaErrata";
		}
		else {
			mySock.manda(a);	
			mySock.manda(b);
			mySock.manda(c);
			mySock.mandachiaro();
			gest.memRst(iniz);
			try {
				processaErrore((String)a,dom,user,(String)b);
			} catch (Exception e) {}
			return "RichiestaInoltrata";
		}
		
	}
	private void processaErrore(String err,String dom,String user,String tipo) {
		if(err.equals("Error")) {
			if(gest.verbose)  System.out.println("Processo Errore");
			if(tipo.equals("UtenteNonRegistrato")) nr_usr_cache.insert(dom,user);
			if(tipo.equals("UtenteRifiutato")) na_usr_cache.insert(dom,user);
			if(tipo.equals("ConnessioneFallita")) nt_dom_cache.insert(dom);
			if(tipo.equals("RispostaErrata")) nt_dom_cache.insert(dom);
			if(tipo.equals("CacheUtenteBloccato")) na_usr_cache.insert(dom,user);
			if(tipo.equals("CacheDominioNonTrovato")) nt_dom_cache.insert(dom);
			if(tipo.equals("CacheUtenteNonRiconosciuto")) nr_usr_cache.insert(dom,user);
			if(tipo.equals("CacheUtenteRifiutato")) na_usr_cache.insert(dom,user);
			if(tipo.equals("Loop")) nt_dom_cache.insert(dom);
		}
	}
	private void mandaErrore(String err) {
		if(gest.verbose) System.out.println("manda errore : "+err);
		mySock.manda("Error");	
		mySock.manda(err);
		mySock.manda(gest.getMe());
		mySock.mandachiaro();
	}
	//private void mandaTicket(String err) {
	//	System.out.println("manda errore : "+err);
	//	mySock.manda("Error");	
	//	mySock.manda(err);
	//	mySock.manda(gest.getMe());
	//	mySock.mandachiaro();
	//}
	private String creaUtente(String nome,String pass) {
		try {
			/*
			Signature md5_rsa = Signature.getInstance("MD5/RSA", "IAIK");
	 		md5_rsa.initSign(gest.getPrivateKey()); 
			md5_rsa.update(nome.getBytes());
			md5_rsa.update(pass.getBytes());
			byte[] arr = md5_rsa.sign();
	 		utentiPass.put(nome,new String(arr));
	 		*/
	 		utentiPass.put(nome,pass);
	 		return "Creato";
		} catch(Exception e) {
			
			return "NonCreato";	
		}	
	}
	private String salvaUtenti(String nome) {
		try {
			byte[] oo = Cript.ObjToByte(utentiPass);
			oo = Cript.cripta(oo,gest.getPrivateKey());
			FileOutputStream ostream1 = new FileOutputStream(nome+".psw");
			ObjectOutputStream p1 = new ObjectOutputStream(ostream1);
			p1.writeObject(oo);
			p1.flush();
			ostream1.close();
			return "Salvato";
		} catch(Exception e) {
			
			return "NonSalvato";	
		}	
	}
	private String verificoBlocchi(String dom,String user) {
		//private Cache nt_dom_cache; /*  domini non trovati */
		//private Cache na_usr_cache; /*  utenti non abilitati per il remoto registrati come dom:user  */
		//private Cache nr_usr_cache; /*  utenti non riconosciuti per il remoto registrati come dom:user  */
		//private Cache b_cache; /*  utenti locali (chiave) bloccati con motivo come risposta  */
		if(gest.verbose) System.out.println("verificoBlocchi "+dom+user);
		String nt = nt_dom_cache.get(dom);
		String na = na_usr_cache.get(dom,user);
		String nr = nr_usr_cache.get(dom,user);
		String b = b_cache.get(user);
		if(gest.verbose) System.out.println("Cache "+nt+na+nr+b);
		if ( dom.equals(gest.dominio()) && (!b.equals(""))) return "CacheUtenteBloccato";
		else {
			if ( !nt.equals("")) return "CacheDominioNonTrovato";
			else {
				if ( !nr.equals("")) return "CacheUtenteNonRiconosciuto";
				else {
					if ( !na.equals("")) return "CacheUtenteRifiutato";
					else return "";
				}
			}
			
		}
		
		
		
	}

	
	
}