package servizi;



import java.io.*;
import java.awt.*;

import java.util.*;
import iaik.security.rsa.*;
import java.security.*;
import java.security.spec.*;


import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;

import java.io.*;
import iaik.security.rsa.*;
import javax.crypto.*;
import iaik.utils.CryptoUtils;
import iaik.security.provider.IAIK;

import iaik.utils.*;


import java.security.*;
import java.security.spec.*;
//import java.security.interfaces.*;
import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;



import Gestore_Connessione;
import ServiceHash;
import MyCertificate;
import Connessione;
import Firma;
import MyKeyStore;

public class ServCert extends Servizio {
	
	private RSAPublicKey certPubKey;
	private RSAPrivateKey certPriKey;
	private MyKeyStore certks;
	
	public ServCert() {
		super();
		descrizione = "Servizi di certificazione";
		nome = "ServCert";
		servizi = new String[1];
		servizi[0] = "Cert";
		
		servTerm = new String[3];
		servTerm[0] = "certifica ,<adress> <dominio> <nome>, crea nuovo certificato e chiave privata "; 
		servTerm[1] = "creaChiavi ,<nome>, crea nuova coppia di chiavi"; 
		servTerm[2] = "salvaCert ,<nome>, salva i certificati in un file"; 
	}
	//metti a posto gli eventi
	public String risposta(String nomeserv,Object arg) {
			// richiesta da client (remoto)
		if(nomeserv.equals("Cert")&&connesso) { 
			//Firma fir = mySock.getFirma();	
			//if(!(servHash.richiedi("verificaFirma",fir,null).startsWith("Valida-")))
			//	return "FirmaNonValida";
			return controllaCertificato();
			
		}
			
		
		return "0";
	}	
	
	public String rispostaTerminale(String nomeserv,String arg) {
		if(nomeserv.equals("certifica")&&(!connesso)) { 
			//String nomi = nomeserv.substring(7).trim();
			if(arg!=null) {
				
				String aa = ((String) arg).trim();
				int pos = aa.indexOf(" ");
				int pos1 = aa.lastIndexOf(" ");
				String addr;
				String dom;
				String nome;
				if(pos == -1) return "IndirizzoNonSpec";
				if(pos1 == -1) return "IndirizzoNonSpec";
				if(pos == pos1) return "NomeNonSpec";
				
				addr = aa.substring(0,pos).trim();
				dom = aa.substring(pos+1,pos1).trim();
				nome = aa.substring(pos1+1,aa.length()).trim();
				 
				return creaCertificato(addr,dom,nome);
				
			} else {
				return "NonHoArgomenti";
			}
		}
		if(nomeserv.equals("creaChiavi")&&(!connesso)) { 
			//String nomi = nomeserv.substring(7).trim();
			if(arg!=null) {
				
				String nome = ((String) arg).trim();
				
				 
				return creaChiavi(nome);
				
			} else {
				return "NonHoArgomenti";
			}
		}
		if(nomeserv.equals("salvaCert")&&(!connesso)) { 
			//String nomi = nomeserv.substring(7).trim();
			if(arg!=null) {
				
				String nome = ((String) arg).trim();
				
				 
				return salvaCertificati(nome);
				
			} else {
				return "NomeFileNonSpecificato";
			}
		}
		return null;
	
	}		
	
	// ripristina prevede serializzazione anche di oggetti
	public void inizializza(Gestore_Connessione g,ServiceHash sh) {
		// da ridefinire se la serializzazione prevede cose particolari
		inizializza_p(g,sh);
	
		try {		
			certPubKey = (RSAPublicKey) gest.carica(nome+".certificatore PublicKey");
			certPriKey = (RSAPrivateKey) gest.carica(nome+".certificatore PrivateKey");
			certks = (MyKeyStore) gest.carica(nome+".certificatore keystore");;
			if(certks == null) certks = new MyKeyStore(certPubKey);
			
		} catch (Exception E) {System.out.println("configura : "+E.getMessage());}
		
	}
	public void prepTrasporto() {
		azzera_p();
		
		
		
	}
	public void riprTrasporto(Gestore_Connessione g,ServiceHash sh) {
		// serve per ripristinare il Servizio dal trasporto
		// da ridefinire se il ripristino prevede cose particolari
		inizializza_p(g,sh);
		//metto a posto : passa da slave a master
		
		
	}
	public void azzera() {
		// da ridefinire se la serializzazione prevede cose particolari
		azzera_p();
		
	
	}	
	public String controllaCertificato() {
		String resp = null;
		byte[] f = (byte[]) mySock.leggi();
		MyCertificate  cert = certks.getCertificateByFirma(f);
		if (cert == null ) resp = "NonRiconosciuto";	
		else resp = cert.getAddress()+"-"+cert.getAlias();
		mySock.firma(gest.getMe());
		mySock.manda(resp);
		mySock.mandachiaro();
	
		if (cert == null ) return "CertificatoAutenticato-"+resp;	
		else return "CertificatoNonRiconosciuto";	
		
	}
	private String creaCertificato(String addr,String dom,String nome) {
	
		int pos = addr.indexOf(":");
		if(pos == -1) return "IndirizzoNonValido";
		String port = addr.substring(pos+1,addr.length());
		try {
			new Integer(port);
		}catch(Exception e) {
			return "portaNonValida";
		}
	
		try {				
			
			RSAKeyPairGenerator KpairGen = (RSAKeyPairGenerator) KeyPairGenerator.getInstance("RSA","IAIK");
	 		KpairGen.initialize(1024,new SecureRandom());
			KeyPair Kpair = KpairGen.generateKeyPair();
			
			RSAPublicKey PuKey = (RSAPublicKey) Kpair.getPublic();
			RSAPrivateKey PrKey = (RSAPrivateKey) Kpair.getPrivate();
			
			MyCertificate cert = new MyCertificate();
			cert.crea(certPriKey ,PuKey,dom,addr,gest.getMe(),gest.dominio());
			
			FileOutputStream ostream1 = new FileOutputStream(nome+".cer");
			FileOutputStream ostream2 = new FileOutputStream(nome+".prk");
			ObjectOutputStream p1 = new ObjectOutputStream(ostream1);
			p1.writeObject(cert);
			
			p1.flush();
			ostream1.close();
			
			
			ObjectOutputStream p2 = new ObjectOutputStream(ostream2);
			
			p2.writeObject(PrKey);
			p2.flush();
			ostream2.close();	
			if(certks.add(cert)) { if(gest.verbose) System.out.println("aggiunto certificato"); }
			else { if(gest.verbose) System.out.println("non aggiunto certificato"); }
			//System.out.println("Chiave Privata "+prkey+".prk salvata");
			return "Creata-"+nome;
		} catch(Exception e) {
			System.out.println("cert error : "+e.getMessage());
			return "NonCreata";
		
		}
		
	}
	private String salvaCertificati(String nome) {
		try {				
			FileOutputStream ostream1 = new FileOutputStream(nome+".ks");
			ObjectOutputStream p1 = new ObjectOutputStream(ostream1);
			p1.writeObject(certks);
			p1.flush();
			ostream1.close();
			return "Salvati";
		} catch(Exception e) {
			System.out.println("salvaCertificati error : "+e.getMessage());
			return "NonSalvati";
		
		}
			
		
	}
	private String creaChiavi(String nome) {
	
		
	
		try {				
			
			RSAKeyPairGenerator KpairGen = (RSAKeyPairGenerator) KeyPairGenerator.getInstance("RSA","IAIK");
	 		KpairGen.initialize(1024,new SecureRandom());
			KeyPair Kpair = KpairGen.generateKeyPair();
			
			RSAPublicKey PuKey = (RSAPublicKey) Kpair.getPublic();
			RSAPrivateKey PrKey = (RSAPrivateKey) Kpair.getPrivate();
			
			FileOutputStream ostream1 = new FileOutputStream(nome+".puk");
			FileOutputStream ostream2 = new FileOutputStream(nome+".prk");
			ObjectOutputStream p1 = new ObjectOutputStream(ostream1);
			p1.writeObject(PuKey);
			
			p1.flush();
			ostream1.close();
			
			ObjectOutputStream p2 = new ObjectOutputStream(ostream2);
			
			p2.writeObject(PrKey);
			p2.flush();
			ostream2.close();	
			
			System.out.println("Coppia Chiavi Create");
			return "Creata-"+nome;
		} catch(Exception e) {
			System.out.println("cert error : "+e.getMessage());
			return "NonCreata";
		
		}
		
	}
	
	
	
	
}