package servizi;

import java.sql.*;
import java.net.*;
import java.io.*;
import java.awt.*;

import java.util.*;
import iaik.security.rsa.*;
import java.security.*;
import java.security.spec.*;


import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;
import Gestore_Connessione;
import ServiceHash;
import Connessione;


public class ServMirror extends Servizio {
	
	
	public ServMirror() {
		super();
		descrizione = "Servizi di Mirror";
		nome = "ServMirror";
		servizi = new String[2];
		servizi[0] = "CreaMir";
		servizi[1] = "MirReq";
		// il comando deve essere comando,argomenti,descrizione
		servTerm = new String[1];
		servTerm[0] = "CreaMir,<slave_server> , crea mirror di questo server su slave_server";
	}
	
	public String risposta(String nomeserv,Object arg) {
		
		if(nomeserv.equals("CreaMir")) { 
			
			return creaMirror((String) arg);
			
		}
		// RIMETTERE if(nomeserv.equals("MirReq")&&RSAcriptato) { 
		if(nomeserv.equals("MirReq")) { 
			return MirReq();
			
		}
		
		return "-0";
	    
		
	}
	
	public String rispostaTerminale(String nomeserv,String arg) {
		if(nomeserv.equals("CreaMir")) {
			return creaMirror(arg);
		
		}
		return null;
	
	}
	private String creaMirror(String server) {
		try{
			Connessione con = new Connessione(gest.getMe());
			if(!gestRic.attiva("Conn",server,con).startsWith("ServConn-Conn-Attivata-"))
				return "ConnNonAtt-"+server;
			//  RIMETTERE if(con.stato()&&con.RSAPubKey()) {
			if(con.stato()) {
				System.out.println("connessione CREAMIRROR attivata");	
				
				String[] servizi = servHash.nomiServ();
				int len = java.lang.reflect.Array.getLength(servizi);
				System.out.println("connessione 1");
				if(len >0 ) {
					con.manda("MirReq");	
					System.out.println("connessione 2");
					int i;
					for(i = 0 ;i < len;i++) {
						Servizio ser = servHash.richiediServ(servizi[i]);
						Servizio ser1 = ser.mioClone();
						System.out.println("connessione 0 "+i);
						ser1.prepTrasporto();
						System.out.println("connessione 0 "+i);
						con.manda(ser1);
						System.out.println("mandato servizio :"+ser1.nome());
						
					}
					con.manda("fine");
					System.out.println("connessione 2");
					// RIMETTERE con.mandacriptato();
					con.mandachiaro();
					con.leggicriptato();
					Object l = con.leggi();
					if(con.stato()) {
						try {
							String ok = (String) l;
							if(ok.equals("Ricevuto")) {
								System.out.println("inviato"); //togli
								return "MirrorCreato-"+server;
							}
							else return "MirrorError";
						} catch(Exception e) {
							return "MirrorError";
						}
					}else {
						return "NonInviato";
					}
					
				} else return "ZeroServizi";
			} else return "ConnNonAtt-"+server;
		} catch(Exception e) {
			System.out.println("error CREAMIRROR "+e.getMessage());
			return "-1";
		}
	}
	private String MirReq()  {
		Vector v_s = new Vector();			
		try {
			//String mitt = (String) mySock.leggi();
			System.out.println("mittente :"+mySock.chi());
			Object o;
			
			boolean cont = true;
			while(cont) {
				o = mySock.leggi();
				try {
					String fine = (String) o;
					if(fine.equals("fine")) {
						System.out.println("trovata fine ");
						cont = false;
						mySock.manda("Ricevuto");
						mySock.mandachiaro();
					}
					else return "fineNonValida";
					
				} catch(Exception e) {
					try {
						Servizio sv = (Servizio) o;
						if(sv ==null) System.out.println("servizio nullo");
						else {
							System.out.println("Servizio nome "+sv.nome());
							v_s.add(sv);
						}
						sv.riprTrasporto(gest,servHash);
						servHash.aggiorna(sv);
					} catch(Exception ee) {
						System.out.println("Servizio Non Valido "+ee.getMessage());
						return "ServizioNonValido";
						
					}
				}
 			}
 				
						
		} catch(Exception e) {
			System.out.println("Errore in MirReq "+e.getMessage());
			return "RicezError";
		}
		Servizio sv;
		int len = v_s.size();
		for(int i =0;i<len;i++) {
			sv = (Servizio) v_s.get(i);
			//sv.riprTrasporto(gest,servHash);
			//servHash.aggiorna(sv);
			sv.autoEsegui();
		}
		return "Ricez."+len;
	
	}
	
}