package servizi;

import java.sql.*;
import java.net.*;
import java.io.*;
import java.awt.*;

import java.util.*;
import iaik.security.rsa.*;
import java.security.*;
import java.security.spec.*;


import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;
import Gestore_Connessione;
import ServiceHash;
import Tempo;



public class ServStat extends Servizio {
	private int partito;
	private int t_controllo;
	private int perc_Congestioni;  //supera la percentuale di congestioni nell'intervallo
	private int media_Thread;  //la media di thread attivi supera il tot
	private int cicli_controllo;
	//private Integer num_cicli;
	private Hashtable t_thread;
	private Hashtable t_congestione;
	
	public ServStat() {
		super();
		descrizione = "Servizi di statistica";
		nome = "ServStat";
		partito =0;
		servizi = new String[3];
		servizi[0] = "StatThread";
		servizi[1] = "StatCongestione";
		servizi[2] = "RiepilogoCongestione";
		eventi = new String[2];
		eventi[0] = "Start-Threads-all-1";
		eventi[1] = "Congestione-Threads-all-1";
		
	}
	public String gestEventi(String ev) {
		if(ev.startsWith("ServMirror-CreaMir-MirrorCreato-")) {
			String ser  = ev.substring(32);
			System.out.println("gestev : "+ser);
			//cancServer(ser);
			
		}
		if(ev.startsWith("Start-Threads-")) {
			//String num  = ev.substring(14);
			//gestRic.attiva("StatThread",ev,null);
			String num = ev.substring(14);
			System.out.println("gestione thread "+num);
			return gestioneThread(num);			
		}
		if(ev.startsWith("Congestione-Threads-")) {
			//String num  = ev.substring(14);
			//gestRic.attiva("StatCongestione",ev,null);
			String num = ev.substring(20);
			System.out.println("gestion congestione "+num);
			return gestioneCongestione(num);			
		}
		return ev;
		
	}
	//metti a posto gli eventi
	public String risposta(String nomeserv,Object arg) {
		 System.out.println("risposta a : "+nomeserv+" connesso "+connesso+" arg "+argomenti);
		if (nomeserv.equals("StatThread")&&(!connesso)&&argomenti) {
			try {
				String num = ((String) arg).substring(14);
				System.out.println("gestione thread "+num);
				return gestioneThread(num);
			} catch(Exception e) {
				 System.out.println("ArgomentoNonValido "+e.getMessage());
				 return "ArgomentoNonValido";
				 
			}
				
				
		}
	    	if (nomeserv.equals("StatCongestione")&&(!connesso)&&argomenti) {
			try {
				String num = ((String) arg).substring(20);
				System.out.println("gestion congestione "+num);
				return gestioneCongestione(num);
				
			} catch(Exception e) {
				 System.out.println("ArgomentoNonValido "+e.getMessage());
				 return "ArgomentoNonValido";
				 
			}
				
				
		}
		if (nomeserv.equals("RiepilogoCongestione")) {
			try {
				 ((statistica) arg).set(riepilogo());
				//((String) arg).concat(riepilogo());
				
				return "Effettuato";
				
			} catch(Exception e) {
				 System.out.println("ArgomentoNonValido "+e.getMessage());
				 return "NonEffettuato";
				 
			}
				
				
		}
		return "0";
	}	
	private String gestioneThread(String num) {
		String k = ""+(new Tempo()).mil_ora();
		System.out.println("gest tr "+k+" "+num);
		t_thread.put(k,num);
		
		return controlla();
		
	}
	private String gestioneCongestione(String num) {
		t_congestione.put(""+(new Tempo()).mil_ora(),num);
		
		return controlla();
		
	}
	private boolean scaduto(String val,int ora) {
		int v = Integer.parseInt(val);
//		System.out.println(v+" + "+t_controllo+" > "+ora);
		return ( (v+t_controllo) > ora) ? false : true;
		
	}
	private synchronized String riepilogo() {
		System.out.println("riepilogo");
		int tot_c = 0;
		int ora = (new Tempo()).mil_ora();
		
		for (Enumeration e = t_congestione.keys() ; e.hasMoreElements() ;) {
			String val =(String) e.nextElement();
         		if(!scaduto(val,ora)) tot_c++;
         	
		}
		int tot_t = 0;
		float somma = 0;
		for (Enumeration h = t_thread.keys() ; h.hasMoreElements() ;) {
			String val =(String) h.nextElement();
         		if(!scaduto(val,ora)) {
         			//System.out.println("valore : "+val+" ora "+ora);
         			tot_t++;
         			String temp = (String) t_thread.get(val);
         			somma+= Integer.parseInt(temp)+1;
				//System.out.println("aggiunto alla somma "+temp+1);	         				
         		} 
  	
		}
		if(tot_t > 0) somma = (somma/tot_t);
		System.out.println("riepilogo Numero thread esaminati "+tot_t);
		System.out.println("riepilogo Percentuale thread attivi :"+somma+" soglia "+((float) gest.getThreads()* media_Thread /100));
		System.out.println("riepilogo congestioni :"+tot_c+" soglia "+((float) tot_t * perc_Congestioni / 100));
		
		float uno = ((float) tot_c) / ((float) tot_t * perc_Congestioni / 100);// Percentuale congestioni rispetto alla soglia
		float due = somma /((float) gest.getThreads()* media_Thread /100); // Percentuale thread attivi rispetto alla soglia
		return ""+uno+":"+due;
	}
	private synchronized String controlla(){
		//num_cicli = new Integer(num_cicli.intValue()+1);
		Integer a = (Integer)gest.memGet(nome,"numcicli");
		int num_ciclix;
		if ( a == null) num_ciclix = 0;
		else num_ciclix = a.intValue()+1;
		if(num_ciclix == cicli_controllo) {
			int tot_c = 0;
			int ora = (new Tempo()).mil_ora();
			gest.memPut(new Integer(0),nome,"numcicli");
			for (Enumeration e = t_congestione.keys() ; e.hasMoreElements() ;) {
				String val =(String) e.nextElement();
	         		if(!scaduto(val,ora)) {
	         			tot_c++;
	         				
	         		} else t_congestione.remove(val);
          	
 			}
 			int tot_t = 0;
 			float somma = 0;
			for (Enumeration h = t_thread.keys() ; h.hasMoreElements() ;) {
				String val =(String) h.nextElement();
	         		if(!scaduto(val,ora)) {
	         			//System.out.println("valore : "+val+" ora "+ora);
	         			tot_t++;
	         			String temp = (String) t_thread.get(val);
	         			somma+= Integer.parseInt(temp)+1;
					if(gest.verbose) System.out.println("aggiunto alla somma "+temp+1);	         				
	         		} else t_thread.remove(val);
          	
 			}
			if(tot_t > 0) somma = (somma/tot_t);
			System.out.println("Numero thread esaminati "+tot_t);
			System.out.println("Percentuale thread attivi :"+somma+" soglia "+((float) gest.getThreads()* media_Thread /100));
			System.out.println("congestioni :"+tot_c+" soglia "+((float) tot_t * perc_Congestioni / 100));
			if(tot_c >= ((float) tot_t * perc_Congestioni / 100)) {
				System.out.println("congestione");
				return "Congestione";
				
			}
			
			if(somma >= ((float) gest.getThreads()* media_Thread /100)) {
				System.out.println("pericolo congestione");
				return "ProbCongestione";
			}
				
			return "Ok";
			
		} else {
			gest.memPut(new Integer(num_ciclix),nome,"numcicli");
			return "NonControllato "+num_ciclix+"/"+cicli_controllo;
		}
		
		
		
	}
	
	// ripristina prevede serializzazione anche di oggetti
	public void inizializza(Gestore_Connessione g,ServiceHash sh) {
		// da ridefinire se la serializzazione prevede cose particolari
		inizializza_p(g,sh);
		partito =(new Tempo()).mil_ora();
		try {
			t_controllo = Integer.parseInt(gest.trova(nome+".intervallo di controllo"));
			perc_Congestioni = Integer.parseInt(gest.trova(nome+".percentuale di congestioni"));
			media_Thread = Integer.parseInt(gest.trova(nome+".media numero thread attivi"));
			cicli_controllo = Integer.parseInt(gest.trova(nome+".controllo ogni tot thread"));
		} catch (Exception e) {
			t_controllo = 90000;
			perc_Congestioni =20;
			media_Thread =90;
			cicli_controllo =1;
		}
		t_thread = new Hashtable();
		t_congestione = new Hashtable();
		gest.memRst(nome);
		
		
	}
	public void prepTrasporto() {
		
		
		azzera_p();
		partito =0;
		t_thread = null;
		t_congestione = null;
		perc_Congestioni = 0;
		media_Thread = 0;
		cicli_controllo = 0;
		gest.memRst(nome);
		
		
		
	}
	public void riprTrasporto(Gestore_Connessione g,ServiceHash sh) {
		// serve per ripristinare il Servizio dal trasporto
		// da ridefinire se il ripristino prevede cose particolari
		inizializza_p(g,sh);
		//partito = (new Tempo()).mil_ora();
		
		
		
		
		
	}
	public Object vendi() {
		// da ridefinire se il mirroring prevede cose particolari
		// partito e t_controllo t_thread t_congestione perc_Congestioni media_Thread cicli_controllo
		return null;
		
	}
	public void compra(Object o) {
		// da ridefinire se il mirroring prevede cose particolari
		
		
			
		
	}
	public String autoEsegui() {
		if (partito == 0) partito = (new Tempo()).mil_ora();
		if (t_controllo == 0) t_controllo = 10000;
		if (t_thread == null) t_thread = new Hashtable();
		if (t_congestione == null) t_congestione = new Hashtable();
		if (perc_Congestioni == 0) perc_Congestioni = 20;
		if (media_Thread == 0) media_Thread = 90;
		if (cicli_controllo == 0) cicli_controllo = 90;
		
		
		
		return " aaa";
		
	}
	public void azzera() {
		// da ridefinire se la serializzazione prevede cose particolari
		azzera_p();
		partito =0;
		t_controllo = 0;
		t_thread = null;
		t_congestione = null;
		perc_Congestioni = 0;
		media_Thread = 0;
		cicli_controllo = 0;
		gest.memRst(nome);
	
	}	
	
}

class statistica {
	private String st;
	public statistica() {
		
		st ="";	
	}
	public void set(String s) {
		st = s;	
	}
	
	public String get() {
		return st;	
	}
	
}
