package servizi;

import java.sql.*;
import java.net.*;
import java.io.*;
import java.awt.*;

import java.util.*;
import iaik.security.rsa.*;
import java.security.*;
import java.security.spec.*;


import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;

import Gestore_Connessione;
import ServiceHash;
import Cript;
import Connessione;
import GestRichieste;

public class ServTerminal extends Servizio {
	
	private boolean attivo;
	private Hashtable comandi;
	boolean fine;
	public ServTerminal() {
		super();
		fine = false;
		attivo = false;
		descrizione = "Servizi di Terminale Locale e remoto";
		nome = "ServTerminal";
		servizi = new String[1];
		servizi[0] = "TermRemoto";
		//servizi[0] = "AvvTerm";
		//servizi[1] = "TermRemoto";
		//servizi[2] = "AggCom";
		servTerm = new String[1];
		servTerm[0] = "AvvTerm, , avvia il terminale";
		//servTerm[1] = "StopTerm, , chiude il terminale";
		//servTerm[2] = "TermRemoto, <server> , richiede una sessione di terminale remoto";
	
	}

	public String risposta(String nomeserv,Object arg) {
			
		if(nomeserv.equals("TermRemoto")) { 
			String argo;
			try {
				argo = (String)arg;
				System.out.println(" gestisco : "+argo);
			} catch(Exception e) {
				return "";	
			}
			return gestione(argo);
		}
				
		return "-0";
	    
		
	}

	public String rispostaTerminale(String nomeserv,String arg) {
		if(nomeserv.equals("AvvTerm")) { 
			if(!attivo) { 
				attivo = true;
				run();
				return "TerminaleAvviato";	
			}
		}
		/*
		if(nomeserv.equals("StopTerm")) {
			System.out.println("xxxx");
			if(attivo) { 
				System.out.println("yy");
				attivo = false;
				fine = true;
				return "TerminaleChiuso";	
			}
			
		}
		*/
		return "-0";
	
	}
	
	public void azzera() {
		azzera_p();
		attivo = false;
		comandi = null;
		
			
		
	}
	
	public void inizializza(Gestore_Connessione g,ServiceHash sh) {
		// inizializzazione del servizio
		// da ridefinire se la inizializzazione prevede cose particolari
		inizializza_p(g,sh);
		comandi = new Hashtable();
		
		
	}
	public String autoEsegui() {
		// da ridefinire se l'attivazione prevede esecuzione automatica
		String[] serv = servHash.nomiServ();
		//System.out.println("servizi: "+serv);
		int len = java.lang.reflect.Array.getLength(serv);
		if(gest.verbose) System.out.println("num servizi: "+len);
		for(int i = 0; i<len;i++) {
			Servizio sv = servHash.richiediServ(serv[i]);
			if(sv==null) {if(gest.verbose) System.out.println(serv[i]+ "  nullo"); }
			else{ 
				String[] comandi= sv.terminale();
				int num;
				if(comandi != null)
					num = java.lang.reflect.Array.getLength(comandi);
				else num =0;
				for(int j = 0; j<num ; j++) {
					// il comando deve essere nome_server,comando,argomenti,descrizione
					aggiungiComando(sv.nome()+","+comandi[j]);
					//richiedi("AggCom",ser.nome()+","+servizi[i],null);
					
				}
			}
			
		}
		
		
		
		//tt = new terminal(gest,servHash,this);
		
		//tt.start();
		GestRichieste g = new GestRichieste(gest,servHash,"AvvTerm",null,this);
		g.start();
		//run();
		
		return "attivo";
	}
	public void prepTrasporto() {
		// serve per preparare il Servizio al trasporto
		// da ridefinire se la compattazione prevede cose particolari
		azzera_p();
		attivo = false;

		
	}
	public void riprTrasporto(Gestore_Connessione g,ServiceHash sh) {
		// serve per ripristinare il Servizio dal trasporto
		// da ridefinire se il ripristino prevede cose particolari
		inizializza_p(g,sh);
		attivo = true;
	}
	
	
	public String richiediComando(String comando,String arg) {
		if(gest.verbose) System.out.println("richiediComandi :"+comando+"-"+arg);
		String st = (String) comandi.get(comando);
		if(st == null) {
			return "nonTrovato";	
		} else {
			int pos1 = st.indexOf(",");
			st = st.substring(0,pos1).trim();
			return gestRic.attivaTerminale(st,comando,arg);
			/*
			Servizio sv = servHash.richiediServ(st);
			if(sv != null) {
				//Servizio svc = sv.mioClone();
				//svc.nuovoGest(new GestRichieste());
				//return svc.rispostaTerminale(comando,arg);
				//GestRichieste g = new GestRichieste(gest,servHash,comando,arg,sv);
				//g.start();
				return "Servizio "+sv.nome()+" comando "+comando;	
				
			}
			else return "servizio non registrato";	
			*/
		}
	}
	
	public String aggiungiComando(String stcomando) {
			if(comandi == null) {if(gest.verbose)  System.out.println("comandi nullo");}
			String temp = stcomando;
			String nomser,com,desc;
			int num;
			try {
				int pos1 = temp.indexOf(",");
				nomser = temp.substring(0,pos1).trim();
				temp = temp.substring(pos1+1);
				
				int pos2 = temp.indexOf(",");
				com = temp.substring(0,pos2).trim();
				desc = temp.substring(pos2+1).trim();
				if(gest.verbose) System.out.println(nomser+","+com+","+desc);
				if((pos1!=-1)&&(pos2!=-1)) {
					comandi.put(com,nomser.concat(","+desc));
					if(gest.verbose) System.out.println("aggiunto :"+com+"-"+nomser);
					return "aggiunto";
				} else return "non aggiunto";
			} catch(Exception e) {
				return "non aggiunto";
			}
		
	}
	
	public String stampaComandi() {
		//System.out.println("stampaComandi");
		String ret="";
		String g;
		String desc;
		//String argom;
		for (Enumeration u = comandi.keys() ; u.hasMoreElements() ;) {
			
	         		g = (String)u.nextElement();
	         		desc = (String) comandi.get(g);
	         		int pos1 = desc.indexOf(",");
				//nomser = desc.substring(0,pos1);
				desc = desc.substring(pos1+1);
	         		//System.out.println(desc); 
	         		//int pos = desc.indexOf(",");
				//argom = desc.substring(pos+1);
	         		ret = ret.concat(g+" "+desc+"\n");
         		}
         	return ret;
		
	}
	public void eliminaComandi(String servizio) {
		String g;
		String desc;
		for (Enumeration u = comandi.keys() ; u.hasMoreElements() ;) {
			g = (String)u.nextElement();
	         		desc = (String) comandi.get(g);
         			if (desc.startsWith(servizio)) {
				comandi.remove(g);
	         		}
	
	
		}	

	}
	public String stampaComandi(String serv) {
		String ret = "";
		String g;
		String desc;
		//String argom;
		for (Enumeration u = comandi.keys() ; u.hasMoreElements() ;) {
			g = (String)u.nextElement();
	         	desc = (String) comandi.get(g);
         		if (desc.startsWith(serv)) {
	         		int pos1 = desc.indexOf(",");
				desc = desc.substring(pos1+1);
		        	ret = ret.concat(g+" ["+desc+" ]\n");
	         	}
         		
         		
         	}
         	return ret;
		
	}
	public String gestione(String command) {
		if(command.equalsIgnoreCase("exit")) { 
			try {
				fine = true;
				gest.termina();
				return "Stopped"; 
			} catch(IOException e) {
				return "Impossibile chiudere il server "+e.getMessage(); 
			}
		}
		if(command.equalsIgnoreCase("Me")) {return gest.getMe();}
		if(command.equalsIgnoreCase("port")) {return gest.getStringPort();}
		if(command.equalsIgnoreCase("IP")) {return gest.getIp();}
		if(command.equalsIgnoreCase("SERVIZI")) {return servHash.stampaServizi("");}
		if(command.toUpperCase().startsWith("SERVIZI ")) {
			String servizio = command.substring(8).trim();
			//System.out.println("Stampo Servizio "+servizio);
			return servHash.stampaServizi(servizio);
			
		}
		if(command.toUpperCase().startsWith("CARICA ")) {
			String servizio = command.substring(7).trim();
			servHash.caricaServizio(servizio);
			Servizio sv = servHash.richiediServ(servizio);
			if(sv==null) return servizio+ " nullo";
			else{ 
				String[] comandi= sv.terminale();
				int num;
				if(comandi != null)
					num = java.lang.reflect.Array.getLength(comandi);
				else num =0;
				for(int j = 0; j<num ; j++) {
					// il comando deve essere nome_server,comando,argomenti,descrizione
					aggiungiComando(sv.nome()+","+comandi[j]);
					//richiedi("AggCom",ser.nome()+","+servizi[i],null);
					
				}
				sv.autoEsegui();
				return servizio+" Caricato";
			}
			
		}
		if(command.toUpperCase().startsWith("SALVA ")) {
			String servizio = command.substring(6).trim();
			servHash.salvaServizio(servizio);
			return servizio+" Salvato";
			
		}
		if(command.toUpperCase().startsWith("STOPTERM")) {
			attivo = false;
			fine = true;
			return "TerminaleChiuso";	
			
			
		}
		if(command.toUpperCase().startsWith("ELIMINA ")) {
			String servizio = command.substring(8).trim();
			if(servHash.elimina(servizio)) {
				//comandi.put(com,nomser.concat(","+desc));
				eliminaComandi(servizio);				
				
			}
			return "";
		}
		if(command.toUpperCase().startsWith("CONGESTIONE")) {
			//GestRichieste g_r = new GestRichieste(gest,servHash,"ServStat-StatCongestione-Congestione");
			//g_r.start();
			//sh.gestioneEvento("ServStat-StatCongestione-Congestione");
			return "";
		}
		if(command.toUpperCase().startsWith("GENERA RSA KEY ")) {
			String nomi = command.substring(15).trim();
			int i = nomi.indexOf(' '); 
			if( i != -1 ) {
				
				String pukey = nomi.substring(0,i).trim();
				String prkey = nomi.substring(i).trim();
				try {
					Cript.generaRSA(pukey,prkey);
				} catch (Exception e) {
					System.out.println("Errore : "+e.getMessage()); 
				}
			
			} else {
				System.out.println("Sintassi Errata"); 
			
			}
			return "gen";
		}
		if(command.equalsIgnoreCase("help")) {
				String ret = "";
				ret = ret.concat("help : questa schermata\n"); 
				ret = ret.concat("StopTerm : chiude il terminale\n"); 
				ret = ret.concat("exit : uscita\n"); 
				ret = ret.concat("ip : mostra indirizzo IP\n"); 
				ret = ret.concat("me : mostra indirizzo ip:port\n"); 
				ret = ret.concat("port : mostra porta ip\n"); 
				ret = ret.concat("servizi : mostra servizi attivi\n");
				ret = ret.concat("carica <nome> : carica il servizio di nome <nome>\n");
				ret = ret.concat("salva <nome> : salva il servizio di nome <nome>\n");
				ret = ret.concat("elimina <nome> : elimina il servizio di nome <nome>\n");
				ret = ret.concat("genera RSA key <public_key> <private_key> : crea coppia di chiavi RSA\n");
				
				ret = ret.concat(stampaComandi());
				return ret;
				
		}	
		if(command.toUpperCase().startsWith("HELP ")) {
			int pos = command.indexOf(" ");
			String com;
			String arg;
			if(pos != -1) {
				arg = command.substring(pos+1).trim();
				return stampaComandi(arg.trim());
			}
			return "HELP : comando non trovato";
				
		}
		int pos = command.indexOf(" ");
		String com;
		String arg;
		if(pos == -1) {
			com = command;
			arg = null;
			//System.out.println(" comando-"+com+"-"+arg);
		} else {
			com = command.substring(0,pos).trim();
			arg = command.substring(pos+1).trim();
			//System.out.println(" comando "+com+" "+arg);
		}
		//String hhh = sh.richiedi(nomser,arg,null);
		// perch l'ho fatta la richiediComando() ?
		return richiediComando(com,arg);
	
	}
	public void run() {
		try {
			while((!gest.fine())&&(!fine)) {
				System.out.print(gest.getMe()+" > ");
				System.out.flush();
				String command;
				
				BufferedReader keyboardInput = new BufferedReader(new InputStreamReader(System.in));
				
				command=keyboardInput.readLine();
				
				System.out.println(">>\n"+gestione(command.trim()));
			}
		} catch(IOException e) {
			System.out.println("Error run : "+e.getMessage()); 	
		}
		
		
		
	}
	public void fine() {
		fine = true;
		
	}
}
