import java.net.Socket;
import java.net.ServerSocket;
import java.io.*;
import java.util.*;
import servizi.*;





public class Server {

	
	
	public static void main(String args[]) {
		
		try {
			Cache c= new Cache(5);
			TickTable t = new TickTable();
			MyCertificate cer = new MyCertificate();
			MyKeyStore ks = new MyKeyStore(null);
			MultiConnessione mc = new MultiConnessione();
			Cript k = new Cript();
								
			java.security.Security.addProvider(new iaik.security.provider.IAIK());
			int g;
			
			
			String fconfig = "config.dat";
			int len = java.lang.reflect.Array.getLength(args);	
			if(len > 0) fconfig = args[0];
				
							
	         	Gestore_Connessione gest = new Gestore_Connessione();
	         	ServiceHash sh = new ServiceHash(gest);
	         	
	         	ServerSocket ServSock = gest.inizializza(fconfig); 
	         	
	         	         	
	         	
	         	String[] servizi = gest.trovatutti("servizio");
			if(len > 1) {
				int len1 = java.lang.reflect.Array.getLength(servizi);
				int lent = len1+len-1; 
				String[] tempservizi = new String[lent];
				for (int i= 0; i<len1;i++) 				
					java.lang.reflect.Array.set(tempservizi,i,servizi[i]); 
				for (int i= len1; i<lent;i++)
					java.lang.reflect.Array.set(tempservizi,i,args[i-len1+1]); 
					
				servizi = tempservizi;
				len = lent;
			}
			else len = java.lang.reflect.Array.getLength(servizi);
			
			for(int i =0;i<len;i++) {
				
				sh.caricaServizio(servizi[i]);
			}
			servizi = sh.nomiServ();
			len = java.lang.reflect.Array.getLength(servizi);
			//System.out.println("Autoeseguo start + "+len);
			for(int i =0;i<len;i++) {
				//System.out.println("Autoeseguo "+i);
				((Servizio) sh.richiediServ(servizi[i])).autoEsegui();
			}
			//System.out.println("Autoeseguo end");
			//-----------------
			
	         	
	         	
	         	
			//sh.richiedi("AvvTerm",null,null,true);
			int nt = gest.getThreads();
	         	GestRichieste[] client = new GestRichieste[nt];
			GestRichieste g_r;
			while (!gest.fine()) {
				
				Connessione theSocket = new Connessione(ServSock.accept(),gest.getPrivateKey(),gest.getMe());
					//for (g=0;g<nt;g++) if((client[g] != null)) if(client[g].stop) stop = true;
                      			for (g=0;g<nt;g++) if ((client[g] == null) || (!client[g].isAlive())) break;

				if (g<nt) {
					client[g] = new GestRichieste(theSocket,g,gest,sh);
					//client[g] = new ServerThread(theSocket,g,gest);
					client[g].start();
					g_r = new GestRichieste(gest,sh,"Start-Threads-"+g);
					g_r.start();
					System.out.println("lanciato Start-Threads");		
				}
				else {
					//sh.gestioneEvento("Congestione-Threads-"+g);
					g_r = new GestRichieste(gest,sh,"Congestione-Threads-"+g);
					g_r.start();
				}
                      		
                      		
			}
			
		} catch (IOException ioE){
			System.out.println("Server end "+ioE.getMessage());
		}
	}
}

