

import java.util.*;
import javax.crypto.*;
import java.io.*;


public class TickTable implements Serializable{

	private int MAX;
	private int refresh;
	private Tempo t;
	private Hashtable ipTable;
	
	public TickTable() {
		ipTable = new Hashtable();
		
	}
	//verifica(usr,tick,tickvec[i])
	public boolean verifica(String ip,String user,byte[] t,Ticket tic) {
	
		//return true;
		
		
		if(tic == null) {
			System.out.println("TickTable : ticket non trovato");
			return false;
		}
		
		if(user.equals(tic.getUser())) {
			if(ip.equals(tic.getIp())) {
				if(tic.confronta(t)) {
					int bora = Integer.parseInt(tic.getOra());
					int validita = Integer.parseInt(tic.getValidita());
					Tempo tem = new Tempo();
					int ora = tem.sec_ora(); 
					int max = tem.sec_max();
					int val;
					if((val = ora-bora)>=0) {
						if(val < validita ) { System.out.println("TickTable : ticket valido");return true;}
						else { System.out.println("TickTable : ticket scaduto");return false;}
					}
					else {
						if((max+val) < validita ) { System.out.println("TickTable : ticket valido");return true;}
						else { System.out.println("TickTable : ticket scaduto");return false;}
					}
					
				} else {
					System.out.println("TickTable : ticket diversi");
					return false;	
				}
			} else {
				System.out.println("TickTable : ip non riconosciuto");
				System.out.println(" ip TIC"+tic.getIp());
				System.out.println(" ip sock"+ip);
				return false;	
			}
		
		} else {
			System.out.println("TickTable : Utente non riconosciuto");
			return false;	
		}
		/*
		System.out.println("t.getIp() : "+t.getIp());
		System.out.println("t.getUser() : "+t.getUser());
		
		if(ip.equals(t.getIp())&user.equals(t.getUser())) {
			
			int bora = Integer.parseInt(t.getOra());
			int validita = Integer.parseInt(t.getValidita());
			Tempo tem = new Tempo();
			int ora = tem.sec_ora(); 
			int max = tem.sec_max();
			int val;
			if((val = ora-bora)>=0) {
					
				if(val < validita ) {
						
					return true;
				}
			}
			else if((max+val) < validita ) return true; 
				
			
		}
		return false;
	
		*/
		
	
	}
	public synchronized void insert(String ip,Ticket t) {
		Vector temp;
		if(ipTable.containsKey(ip)) temp = (Vector) ipTable.get(ip);
		else temp = new Vector();
		temp.add(t);
		ipTable.put(ip,temp);
		
		
	
	
	}


	public String stampaTic(){
		String ret ="";
		for (Enumeration u = ipTable.keys() ; u.hasMoreElements() ;) {
			
	         		String ip = (String)u.nextElement();
	         		Ticket[] t = get(ip);
	         		int len = java.lang.reflect.Array.getLength(t);
	          		for(int i=0;i<len;i++) {
	          			ret = ret.concat(ip+" "+t[i].getUser()+" "+t[i].getOra()+"\n");
	         			
	         		}
         		
         		}
		return ret;
		
	}
	public Ticket[] get(String ip) {
	
		if(ipTable.containsKey(ip)) {
			Vector temp = (Vector) ipTable.get(ip);
			int len = temp.size();
			Ticket[] ret = new Ticket[len];
			
			temp.copyInto(ret);
          
          		return ret;
          
		} else {
			return null;
		}		
		
		
	}
	
		
}