
import java.io.*;
import java.util.*;

import iaik.security.rsa.*;
import java.security.*;
import java.security.spec.*;

import javax.crypto.*;
import javax.crypto.spec.*;
import javax.crypto.interfaces.*;

public class Ticket implements Serializable{
	
	SecretKey Ksessiontgs;
	String user;
	String ip;
	int val;
	int ora;
	int num;
	byte[] ticket;
	
	/*
	il ticketsessiontgs  formato da :
	Ksessiontgs,user,time,ip,maxtime 
			criptato con chiave del server tgs
			
	questo arriva al server tgs
	
	il messaggio al client  formato da :
	
	ticketsessiontgs ,Ksessiontgs, numtgs , time, maxtime
			
			criptato con chiave del client
	
	*/
	public Ticket() {
		
	
	}
	public boolean confronta(byte[] t) {
		//Cript.stampa(ticket);
		//Cript.stampa(t);
		int len1 = java.lang.reflect.Array.getLength(ticket);
		int len2 = java.lang.reflect.Array.getLength(t);
		if(len1 != len2 ) return false;
		else for(int i = 0; i<len1 ; i++) if(t[i]!=ticket[i]) return false;
		
		return true;
		
          	
	}
	/*
	public boolean verifica(String addr,String utente) {
		return true;
		
	}
	*/
	public void creaTicket (RSAPublicKey serpubkey,String user,String ip,int val) {
		try {
			Tempo t = new Tempo();
			System.out.println("creaTicket 1");
			this.user = user;
			this.ip = ip;
			this.val = val;
			this.ora = t.sec_ora(); 
			KeyGenerator des_key_gen = KeyGenerator.getInstance("DES");
			this.Ksessiontgs = des_key_gen.generateKey();
			System.out.println("creaTicket 2");
			ByteArrayOutputStream bos = new ByteArrayOutputStream();
			ObjectOutputStream out = new ObjectOutputStream(bos);
			ByteArrayOutputStream tempbos = new ByteArrayOutputStream();
			ObjectOutputStream tempout = new ObjectOutputStream(tempbos);
			System.out.println("creaTicket 3");
			tempout.writeObject(Ksessiontgs);
			tempout.writeObject(user);
			tempout.writeObject(new String(""+ora));
			tempout.writeObject(ip);
			tempout.writeObject(new String(""+val));
			System.out.println("creaTicket 4");
			byte[] ciphertext = Cript.cripta(tempbos.toByteArray(),serpubkey);
			//out.write(ciphertext);
			//ticket = bos.toByteArray();
			System.out.println("creaTicket 4");
			ticket = ciphertext;
			System.out.println("creaTicket 5");
			System.out.println("lunghezza ticket : "+java.lang.reflect.Array.getLength(ticket));
		
		}
		catch(Exception e) { 
			System.out.println("Errore creaTicket "+e.getMessage());
		
		}
	
	}
	public byte[] getTicket() {
		
		return ticket;
		
		
	}
	public String getOra() {
		return new String(""+ora);
	}
	public String getValidita() {
		return new String(""+val);
	}
	public String getUser() {
		return user;
	}
	public String getIp() {
		return ip;
	}
	public SecretKey getKsessiontgs() {
		return Ksessiontgs;
	}
	
	
	public void inizializza(byte[] tick,RSAPrivateKey serprikey) {
		
		try {
			this.ticket = tick;

			//ByteArrayInputStream tempbis = new ByteArrayInputStream(tick);
			//ObjectInputStream tempin = new ObjectInputStream(tempbis);
			
			//byte[] ciphertext = (byte[]) tempin.readObject();
			byte[] ciphertext = tick;
			

			
			byte[] cleartext = Cript.decripta(ciphertext,serprikey);

			ByteArrayInputStream bis = new ByteArrayInputStream(cleartext);

			ObjectInputStream in = new ObjectInputStream(bis);

			Ksessiontgs = (SecretKey) in.readObject();

			user = (String) in.readObject();
			
			ora = Integer.parseInt((String) in.readObject());
			
			ip = (String) in.readObject();
			
			val = Integer.parseInt((String) in.readObject());
			
		} catch (Exception e) {
			System.out.println("Errore in inizializza "+e.getMessage());
			
		}
		
	}
	
	// ticketsessiontgs ,Ksessiontgs, numtgs , time, maxtime
	public byte[] getMessaggio(int num) {
		try {
			//ByteArrayOutputStream bos = new ByteArrayOutputStream();
			//ObjectOutputStream out = new ObjectOutputStream(bos);
			ByteArrayOutputStream tempbos = new ByteArrayOutputStream();
			ObjectOutputStream tempout = new ObjectOutputStream(tempbos);
			
			tempout.writeObject(ticket);
			tempout.writeObject(Ksessiontgs);
			tempout.writeObject(new String(""+num));
			tempout.writeObject(new String(""+ora));
			tempout.writeObject(new String(""+val));
			//Cipher rsa = Cipher.getInstance("RSA");
		      	//rsa.init(Cipher.ENCRYPT_MODE,clpubkey);
			//byte[] ciphertext = rsa.doFinal(tempbos.toByteArray());
			//out.write(ciphertext);
			return tempbos.toByteArray();
		} catch (Exception e) {
			return null;
		}
	}	
	
	public void setMessaggio(byte[] msg) {
		
		try {
			
			
			ByteArrayInputStream bis = new ByteArrayInputStream(msg);
			ObjectInputStream in = new ObjectInputStream(bis);
			
			ticket = (byte[]) in.readObject();
			Ksessiontgs = (SecretKey) in.readObject();
			if(Ksessiontgs == null) System.out.println("session key null");
			num = Integer.parseInt((String) in.readObject());
			ora = Integer.parseInt((String) in.readObject());
			val = Integer.parseInt((String) in.readObject());
		} catch (Exception e) {
			System.out.println("Errore setMessaggio : "+e.getMessage());
			
		}
		
	}	
		
}